# -*- coding: mbcs -*-

from ctypes import *
from comtypes import COMMETHOD, GUID, IUnknown, wireHWND
from comtypes.typeinfo import ULONG_PTR
from . import OLE
from ctypes import HRESULT
from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from comtypes import hints


_lcid = 0  # change this if required
typelib_path = None
STRING = c_char_p
WSTRING = c_wchar_p

# values for enumeration 'D3D12_MESSAGE_SEVERITY'
D3D12_MESSAGE_SEVERITY_CORRUPTION = 0
D3D12_MESSAGE_SEVERITY_ERROR = 1
D3D12_MESSAGE_SEVERITY_WARNING = 2
D3D12_MESSAGE_SEVERITY_INFO = 3
D3D12_MESSAGE_SEVERITY_MESSAGE = 4
D3D12_MESSAGE_SEVERITY = c_int  # enum

# values for enumeration 'D3D12_CPU_PAGE_PROPERTY'
D3D12_CPU_PAGE_PROPERTY_UNKNOWN = 0
D3D12_CPU_PAGE_PROPERTY_NOT_AVAILABLE = 1
D3D12_CPU_PAGE_PROPERTY_WRITE_COMBINE = 2
D3D12_CPU_PAGE_PROPERTY_WRITE_BACK = 3
D3D12_CPU_PAGE_PROPERTY = c_int  # enum

# values for enumeration 'D3D12_MESSAGE_CATEGORY'
D3D12_MESSAGE_CATEGORY_APPLICATION_DEFINED = 0
D3D12_MESSAGE_CATEGORY_MISCELLANEOUS = 1
D3D12_MESSAGE_CATEGORY_INITIALIZATION = 2
D3D12_MESSAGE_CATEGORY_CLEANUP = 3
D3D12_MESSAGE_CATEGORY_COMPILATION = 4
D3D12_MESSAGE_CATEGORY_STATE_CREATION = 5
D3D12_MESSAGE_CATEGORY_STATE_SETTING = 6
D3D12_MESSAGE_CATEGORY_STATE_GETTING = 7
D3D12_MESSAGE_CATEGORY_RESOURCE_MANIPULATION = 8
D3D12_MESSAGE_CATEGORY_EXECUTION = 9
D3D12_MESSAGE_CATEGORY_SHADER = 10
D3D12_MESSAGE_CATEGORY = c_int  # enum

# values for enumeration 'D3D12_MESSAGE_ID'
D3D12_MESSAGE_ID_UNKNOWN = 0
D3D12_MESSAGE_ID_STRING_FROM_APPLICATION = 1
D3D12_MESSAGE_ID_CORRUPTED_THIS = 2
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER1 = 3
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER2 = 4
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER3 = 5
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER4 = 6
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER5 = 7
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER6 = 8
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER7 = 9
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER8 = 10
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER9 = 11
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER10 = 12
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER11 = 13
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER12 = 14
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER13 = 15
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER14 = 16
D3D12_MESSAGE_ID_CORRUPTED_PARAMETER15 = 17
D3D12_MESSAGE_ID_CORRUPTED_MULTITHREADING = 18
D3D12_MESSAGE_ID_MESSAGE_REPORTING_OUTOFMEMORY = 19
D3D12_MESSAGE_ID_GETPRIVATEDATA_MOREDATA = 20
D3D12_MESSAGE_ID_SETPRIVATEDATA_INVALIDFREEDATA = 21
D3D12_MESSAGE_ID_SETPRIVATEDATA_CHANGINGPARAMS = 24
D3D12_MESSAGE_ID_SETPRIVATEDATA_OUTOFMEMORY = 25
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_UNRECOGNIZEDFORMAT = 26
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDESC = 27
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFORMAT = 28
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDVIDEOPLANESLICE = 29
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDPLANESLICE = 30
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDIMENSIONS = 31
D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDRESOURCE = 32
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_UNRECOGNIZEDFORMAT = 35
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_UNSUPPORTEDFORMAT = 36
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDESC = 37
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDFORMAT = 38
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDVIDEOPLANESLICE = 39
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDPLANESLICE = 40
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDIMENSIONS = 41
D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDRESOURCE = 42
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_UNRECOGNIZEDFORMAT = 45
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDESC = 46
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFORMAT = 47
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDIMENSIONS = 48
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDRESOURCE = 49
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_OUTOFMEMORY = 52
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TOOMANYELEMENTS = 53
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDFORMAT = 54
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INCOMPATIBLEFORMAT = 55
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOT = 56
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDINPUTSLOTCLASS = 57
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_STEPRATESLOTCLASSMISMATCH = 58
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOTCLASSCHANGE = 59
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSTEPRATECHANGE = 60
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDALIGNMENT = 61
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_DUPLICATESEMANTIC = 62
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_UNPARSEABLEINPUTSIGNATURE = 63
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_NULLSEMANTIC = 64
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_MISSINGELEMENT = 65
D3D12_MESSAGE_ID_CREATEVERTEXSHADER_OUTOFMEMORY = 66
D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERBYTECODE = 67
D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERTYPE = 68
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_OUTOFMEMORY = 69
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERBYTECODE = 70
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERTYPE = 71
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTOFMEMORY = 72
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERBYTECODE = 73
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE = 74
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMENTRIES = 75
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSTREAMSTRIDEUNUSED = 76
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSLOT0EXPECTED = 79
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSLOT = 80
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_ONLYONEELEMENTPERSLOT = 81
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCOMPONENTCOUNT = 82
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTARTCOMPONENTANDCOMPONENTCOUNT = 83
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDGAPDEFINITION = 84
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_REPEATEDOUTPUT = 85
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSTREAMSTRIDE = 86
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGSEMANTIC = 87
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MASKMISMATCH = 88
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_CANTHAVEONLYGAPS = 89
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DECLTOOCOMPLEX = 90
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGOUTPUTSIGNATURE = 91
D3D12_MESSAGE_ID_CREATEPIXELSHADER_OUTOFMEMORY = 92
D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERBYTECODE = 93
D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERTYPE = 94
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFILLMODE = 95
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDCULLMODE = 96
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDDEPTHBIASCLAMP = 97
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDSLOPESCALEDDEPTHBIAS = 98
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHWRITEMASK = 100
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHFUNC = 101
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFAILOP = 102
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILZFAILOP = 103
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILPASSOP = 104
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFUNC = 105
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFAILOP = 106
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILZFAILOP = 107
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILPASSOP = 108
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFUNC = 109
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLEND = 111
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLEND = 112
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOP = 113
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLENDALPHA = 114
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLENDALPHA = 115
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOPALPHA = 116
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDRENDERTARGETWRITEMASK = 117
D3D12_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_INVALID = 135
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ROOT_SIGNATURE_NOT_SET = 200
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ROOT_SIGNATURE_MISMATCH = 201
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_NOT_SET = 202
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_STRIDE_TOO_SMALL = 209
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_TOO_SMALL = 210
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_NOT_SET = 211
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_FORMAT_INVALID = 212
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_TOO_SMALL = 213
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INVALID_PRIMITIVETOPOLOGY = 219
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_STRIDE_UNALIGNED = 221
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_OFFSET_UNALIGNED = 222
D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_AT_FAULT = 232
D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_POSSIBLY_AT_FAULT = 233
D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_NOT_AT_FAULT = 234
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TRAILING_DIGIT_IN_SEMANTIC = 239
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_TRAILING_DIGIT_IN_SEMANTIC = 240
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TYPE_MISMATCH = 245
D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_EMPTY_LAYOUT = 253
D3D12_MESSAGE_ID_LIVE_OBJECT_SUMMARY = 255
D3D12_MESSAGE_ID_LIVE_DEVICE = 274
D3D12_MESSAGE_ID_LIVE_SWAPCHAIN = 275
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFLAGS = 276
D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDCLASSLINKAGE = 277
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDCLASSLINKAGE = 278
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAMTORASTERIZER = 280
D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDCLASSLINKAGE = 283
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAM = 284
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDENTRIES = 285
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTRIDES = 286
D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTRIDES = 287
D3D12_MESSAGE_ID_CREATEHULLSHADER_OUTOFMEMORY = 289
D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERBYTECODE = 290
D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERTYPE = 291
D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDCLASSLINKAGE = 292
D3D12_MESSAGE_ID_CREATEDOMAINSHADER_OUTOFMEMORY = 294
D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERBYTECODE = 295
D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERTYPE = 296
D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCLASSLINKAGE = 297
D3D12_MESSAGE_ID_RESOURCE_UNMAP_NOTMAPPED = 310
D3D12_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_MISMATCHED_DATA_SIZE = 318
D3D12_MESSAGE_ID_CREATECOMPUTESHADER_OUTOFMEMORY = 321
D3D12_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERBYTECODE = 322
D3D12_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCLASSLINKAGE = 323
D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEFLOATOPSNOTSUPPORTED = 331
D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEFLOATOPSNOTSUPPORTED = 332
D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEFLOATOPSNOTSUPPORTED = 333
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEFLOATOPSNOTSUPPORTED = 334
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEFLOATOPSNOTSUPPORTED = 335
D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEFLOATOPSNOTSUPPORTED = 336
D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEFLOATOPSNOTSUPPORTED = 337
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDRESOURCE = 340
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDESC = 341
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFORMAT = 342
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDVIDEOPLANESLICE = 343
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDPLANESLICE = 344
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDIMENSIONS = 345
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_UNRECOGNIZEDFORMAT = 346
D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFLAGS = 354
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFORCEDSAMPLECOUNT = 401
D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDLOGICOPS = 403
D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 410
D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 412
D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 414
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 416
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEEXTENSIONSNOTSUPPORTED = 418
D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 420
D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEEXTENSIONSNOTSUPPORTED = 422
D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_UAVSNOTSUPPORTED = 425
D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_UAVSNOTSUPPORTED = 426
D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_UAVSNOTSUPPORTED = 427
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_UAVSNOTSUPPORTED = 428
D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UAVSNOTSUPPORTED = 429
D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_UAVSNOTSUPPORTED = 430
D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_UAVSNOTSUPPORTED = 431
D3D12_MESSAGE_ID_DEVICE_CLEARVIEW_INVALIDSOURCERECT = 447
D3D12_MESSAGE_ID_DEVICE_CLEARVIEW_EMPTYRECT = 448
D3D12_MESSAGE_ID_UPDATETILEMAPPINGS_INVALID_PARAMETER = 493
D3D12_MESSAGE_ID_COPYTILEMAPPINGS_INVALID_PARAMETER = 494
D3D12_MESSAGE_ID_CREATEDEVICE_INVALIDARGS = 506
D3D12_MESSAGE_ID_CREATEDEVICE_WARNING = 507
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_TYPE = 519
D3D12_MESSAGE_ID_RESOURCE_BARRIER_NULL_POINTER = 520
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_SUBRESOURCE = 521
D3D12_MESSAGE_ID_RESOURCE_BARRIER_RESERVED_BITS = 522
D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISSING_BIND_FLAGS = 523
D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_MISC_FLAGS = 524
D3D12_MESSAGE_ID_RESOURCE_BARRIER_MATCHING_STATES = 525
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMBINATION = 526
D3D12_MESSAGE_ID_RESOURCE_BARRIER_BEFORE_AFTER_MISMATCH = 527
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_RESOURCE = 528
D3D12_MESSAGE_ID_RESOURCE_BARRIER_SAMPLE_COUNT = 529
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAGS = 530
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMBINED_FLAGS = 531
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAGS_FOR_FORMAT = 532
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_SPLIT_BARRIER = 533
D3D12_MESSAGE_ID_RESOURCE_BARRIER_UNMATCHED_END = 534
D3D12_MESSAGE_ID_RESOURCE_BARRIER_UNMATCHED_BEGIN = 535
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAG = 536
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMMAND_LIST_TYPE = 537
D3D12_MESSAGE_ID_INVALID_SUBRESOURCE_STATE = 538
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_CONTENTION = 540
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_RESET = 541
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_RESET_BUNDLE = 542
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_CANNOT_RESET = 543
D3D12_MESSAGE_ID_COMMAND_LIST_OPEN = 544
D3D12_MESSAGE_ID_INVALID_BUNDLE_API = 546
D3D12_MESSAGE_ID_COMMAND_LIST_CLOSED = 547
D3D12_MESSAGE_ID_WRONG_COMMAND_ALLOCATOR_TYPE = 549
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_SYNC = 552
D3D12_MESSAGE_ID_COMMAND_LIST_SYNC = 553
D3D12_MESSAGE_ID_SET_DESCRIPTOR_HEAP_INVALID = 554
D3D12_MESSAGE_ID_CREATE_COMMANDQUEUE = 557
D3D12_MESSAGE_ID_CREATE_COMMANDALLOCATOR = 558
D3D12_MESSAGE_ID_CREATE_PIPELINESTATE = 559
D3D12_MESSAGE_ID_CREATE_COMMANDLIST12 = 560
D3D12_MESSAGE_ID_CREATE_RESOURCE = 562
D3D12_MESSAGE_ID_CREATE_DESCRIPTORHEAP = 563
D3D12_MESSAGE_ID_CREATE_ROOTSIGNATURE = 564
D3D12_MESSAGE_ID_CREATE_LIBRARY = 565
D3D12_MESSAGE_ID_CREATE_HEAP = 566
D3D12_MESSAGE_ID_CREATE_MONITOREDFENCE = 567
D3D12_MESSAGE_ID_CREATE_QUERYHEAP = 568
D3D12_MESSAGE_ID_CREATE_COMMANDSIGNATURE = 569
D3D12_MESSAGE_ID_LIVE_COMMANDQUEUE = 570
D3D12_MESSAGE_ID_LIVE_COMMANDALLOCATOR = 571
D3D12_MESSAGE_ID_LIVE_PIPELINESTATE = 572
D3D12_MESSAGE_ID_LIVE_COMMANDLIST12 = 573
D3D12_MESSAGE_ID_LIVE_RESOURCE = 575
D3D12_MESSAGE_ID_LIVE_DESCRIPTORHEAP = 576
D3D12_MESSAGE_ID_LIVE_ROOTSIGNATURE = 577
D3D12_MESSAGE_ID_LIVE_LIBRARY = 578
D3D12_MESSAGE_ID_LIVE_HEAP = 579
D3D12_MESSAGE_ID_LIVE_MONITOREDFENCE = 580
D3D12_MESSAGE_ID_LIVE_QUERYHEAP = 581
D3D12_MESSAGE_ID_LIVE_COMMANDSIGNATURE = 582
D3D12_MESSAGE_ID_DESTROY_COMMANDQUEUE = 583
D3D12_MESSAGE_ID_DESTROY_COMMANDALLOCATOR = 584
D3D12_MESSAGE_ID_DESTROY_PIPELINESTATE = 585
D3D12_MESSAGE_ID_DESTROY_COMMANDLIST12 = 586
D3D12_MESSAGE_ID_DESTROY_RESOURCE = 588
D3D12_MESSAGE_ID_DESTROY_DESCRIPTORHEAP = 589
D3D12_MESSAGE_ID_DESTROY_ROOTSIGNATURE = 590
D3D12_MESSAGE_ID_DESTROY_LIBRARY = 591
D3D12_MESSAGE_ID_DESTROY_HEAP = 592
D3D12_MESSAGE_ID_DESTROY_MONITOREDFENCE = 593
D3D12_MESSAGE_ID_DESTROY_QUERYHEAP = 594
D3D12_MESSAGE_ID_DESTROY_COMMANDSIGNATURE = 595
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDIMENSIONS = 597
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDMISCFLAGS = 599
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDARG_RETURN = 602
D3D12_MESSAGE_ID_CREATERESOURCE_OUTOFMEMORY_RETURN = 603
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDESC = 604
D3D12_MESSAGE_ID_POSSIBLY_INVALID_SUBRESOURCE_STATE = 607
D3D12_MESSAGE_ID_INVALID_USE_OF_NON_RESIDENT_RESOURCE = 608
D3D12_MESSAGE_ID_POSSIBLE_INVALID_USE_OF_NON_RESIDENT_RESOURCE = 609
D3D12_MESSAGE_ID_BUNDLE_PIPELINE_STATE_MISMATCH = 610
D3D12_MESSAGE_ID_PRIMITIVE_TOPOLOGY_MISMATCH_PIPELINE_STATE = 611
D3D12_MESSAGE_ID_RENDER_TARGET_FORMAT_MISMATCH_PIPELINE_STATE = 613
D3D12_MESSAGE_ID_RENDER_TARGET_SAMPLE_DESC_MISMATCH_PIPELINE_STATE = 614
D3D12_MESSAGE_ID_DEPTH_STENCIL_FORMAT_MISMATCH_PIPELINE_STATE = 615
D3D12_MESSAGE_ID_DEPTH_STENCIL_SAMPLE_DESC_MISMATCH_PIPELINE_STATE = 616
D3D12_MESSAGE_ID_CREATESHADER_INVALIDBYTECODE = 622
D3D12_MESSAGE_ID_CREATEHEAP_NULLDESC = 623
D3D12_MESSAGE_ID_CREATEHEAP_INVALIDSIZE = 624
D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDHEAPTYPE = 625
D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDCPUPAGEPROPERTIES = 626
D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDMEMORYPOOL = 627
D3D12_MESSAGE_ID_CREATEHEAP_INVALIDPROPERTIES = 628
D3D12_MESSAGE_ID_CREATEHEAP_INVALIDALIGNMENT = 629
D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDMISCFLAGS = 630
D3D12_MESSAGE_ID_CREATEHEAP_INVALIDMISCFLAGS = 631
D3D12_MESSAGE_ID_CREATEHEAP_INVALIDARG_RETURN = 632
D3D12_MESSAGE_ID_CREATEHEAP_OUTOFMEMORY_RETURN = 633
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLHEAPPROPERTIES = 634
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDHEAPTYPE = 635
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDCPUPAGEPROPERTIES = 636
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDMEMORYPOOL = 637
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDHEAPPROPERTIES = 638
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDHEAPMISCFLAGS = 639
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDHEAPMISCFLAGS = 640
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDARG_RETURN = 641
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_OUTOFMEMORY_RETURN = 642
D3D12_MESSAGE_ID_GETCUSTOMHEAPPROPERTIES_UNRECOGNIZEDHEAPTYPE = 643
D3D12_MESSAGE_ID_GETCUSTOMHEAPPROPERTIES_INVALIDHEAPTYPE = 644
D3D12_MESSAGE_ID_CREATE_DESCRIPTOR_HEAP_INVALID_DESC = 645
D3D12_MESSAGE_ID_INVALID_DESCRIPTOR_HANDLE = 646
D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALID_CONSERVATIVERASTERMODE = 647
D3D12_MESSAGE_ID_CREATE_CONSTANT_BUFFER_VIEW_INVALID_RESOURCE = 649
D3D12_MESSAGE_ID_CREATE_CONSTANT_BUFFER_VIEW_INVALID_DESC = 650
D3D12_MESSAGE_ID_CREATE_UNORDEREDACCESS_VIEW_INVALID_COUNTER_USAGE = 652
D3D12_MESSAGE_ID_COPY_DESCRIPTORS_INVALID_RANGES = 653
D3D12_MESSAGE_ID_COPY_DESCRIPTORS_WRITE_ONLY_DESCRIPTOR = 654
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RTV_FORMAT_NOT_UNKNOWN = 655
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_RENDER_TARGET_COUNT = 656
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VERTEX_SHADER_NOT_SET = 657
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INPUTLAYOUT_NOT_SET = 658
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_HS_DS_SIGNATURE_MISMATCH = 659
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_REGISTERINDEX = 660
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_COMPONENTTYPE = 661
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_REGISTERMASK = 662
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_SYSTEMVALUE = 663
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_NEVERWRITTEN_ALWAYSREADS = 664
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_MINPRECISION = 665
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_SEMANTICNAME_NOT_FOUND = 666
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_XOR_DS_MISMATCH = 667
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HULL_SHADER_INPUT_TOPOLOGY_MISMATCH = 668
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_DS_CONTROL_POINT_COUNT_MISMATCH = 669
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_DS_TESSELLATOR_DOMAIN_MISMATCH = 670
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_USE_OF_CENTER_MULTISAMPLE_PATTERN = 671
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_USE_OF_FORCED_SAMPLE_COUNT = 672
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_PRIMITIVETOPOLOGY = 673
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_SYSTEMVALUE = 674
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_DUAL_SOURCE_BLENDING_CAN_ONLY_HAVE_RENDER_TARGET_0 = 675
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_RENDER_TARGET_DOES_NOT_SUPPORT_BLENDING = 676
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_OUTPUT_TYPE_MISMATCH = 677
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_RENDER_TARGET_DOES_NOT_SUPPORT_LOGIC_OPS = 678
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RENDERTARGETVIEW_NOT_SET = 679
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_DEPTHSTENCILVIEW_NOT_SET = 680
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_GS_INPUT_PRIMITIVE_MISMATCH = 681
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_POSITION_NOT_PRESENT = 682
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MISSING_ROOT_SIGNATURE_FLAGS = 683
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_INDEX_BUFFER_PROPERTIES = 684
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_SAMPLE_DESC = 685
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_ROOT_SIGNATURE_MISMATCH = 686
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_DS_ROOT_SIGNATURE_MISMATCH = 687
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VS_ROOT_SIGNATURE_MISMATCH = 688
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_GS_ROOT_SIGNATURE_MISMATCH = 689
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_ROOT_SIGNATURE_MISMATCH = 690
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MISSING_ROOT_SIGNATURE = 691
D3D12_MESSAGE_ID_EXECUTE_BUNDLE_OPEN_BUNDLE = 692
D3D12_MESSAGE_ID_EXECUTE_BUNDLE_DESCRIPTOR_HEAP_MISMATCH = 693
D3D12_MESSAGE_ID_EXECUTE_BUNDLE_TYPE = 694
D3D12_MESSAGE_ID_DRAW_EMPTY_SCISSOR_RECTANGLE = 695
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_BLOB_NOT_FOUND = 696
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_DESERIALIZE_FAILED = 697
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_INVALID_CONFIGURATION = 698
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_NOT_SUPPORTED_ON_DEVICE = 699
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLRESOURCEPROPERTIES = 700
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLHEAP = 701
D3D12_MESSAGE_ID_GETRESOURCEALLOCATIONINFO_INVALIDRDESCS = 702
D3D12_MESSAGE_ID_MAKERESIDENT_NULLOBJECTARRAY = 703
D3D12_MESSAGE_ID_EVICT_NULLOBJECTARRAY = 705
D3D12_MESSAGE_ID_SET_DESCRIPTOR_TABLE_INVALID = 708
D3D12_MESSAGE_ID_SET_ROOT_CONSTANT_INVALID = 709
D3D12_MESSAGE_ID_SET_ROOT_CONSTANT_BUFFER_VIEW_INVALID = 710
D3D12_MESSAGE_ID_SET_ROOT_SHADER_RESOURCE_VIEW_INVALID = 711
D3D12_MESSAGE_ID_SET_ROOT_UNORDERED_ACCESS_VIEW_INVALID = 712
D3D12_MESSAGE_ID_SET_VERTEX_BUFFERS_INVALID_DESC = 713
D3D12_MESSAGE_ID_SET_INDEX_BUFFER_INVALID_DESC = 715
D3D12_MESSAGE_ID_SET_STREAM_OUTPUT_BUFFERS_INVALID_DESC = 717
D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDDIMENSIONALITY = 718
D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDLAYOUT = 719
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDIMENSIONALITY = 720
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDALIGNMENT = 721
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDMIPLEVELS = 722
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDSAMPLEDESC = 723
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDLAYOUT = 724
D3D12_MESSAGE_ID_SET_INDEX_BUFFER_INVALID = 725
D3D12_MESSAGE_ID_SET_VERTEX_BUFFERS_INVALID = 726
D3D12_MESSAGE_ID_SET_STREAM_OUTPUT_BUFFERS_INVALID = 727
D3D12_MESSAGE_ID_SET_RENDER_TARGETS_INVALID = 728
D3D12_MESSAGE_ID_CREATEQUERY_HEAP_INVALID_PARAMETERS = 729
D3D12_MESSAGE_ID_BEGIN_END_QUERY_INVALID_PARAMETERS = 731
D3D12_MESSAGE_ID_CLOSE_COMMAND_LIST_OPEN_QUERY = 732
D3D12_MESSAGE_ID_RESOLVE_QUERY_DATA_INVALID_PARAMETERS = 733
D3D12_MESSAGE_ID_SET_PREDICATION_INVALID_PARAMETERS = 734
D3D12_MESSAGE_ID_TIMESTAMPS_NOT_SUPPORTED = 735
D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDFORMAT = 737
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDFORMAT = 738
D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_INVALIDSUBRESOURCERANGE = 739
D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_INVALIDBASEOFFSET = 740
D3D12_MESSAGE_ID_GETCOPYABLELAYOUT_INVALIDSUBRESOURCERANGE = 739
D3D12_MESSAGE_ID_GETCOPYABLELAYOUT_INVALIDBASEOFFSET = 740
D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_HEAP = 741
D3D12_MESSAGE_ID_CREATE_SAMPLER_INVALID = 742
D3D12_MESSAGE_ID_CREATECOMMANDSIGNATURE_INVALID = 743
D3D12_MESSAGE_ID_EXECUTE_INDIRECT_INVALID_PARAMETERS = 744
D3D12_MESSAGE_ID_GETGPUVIRTUALADDRESS_INVALID_RESOURCE_DIMENSION = 745
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDCLEARVALUE = 815
D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDCLEARVALUEFORMAT = 816
D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDCLEARVALUEFORMAT = 817
D3D12_MESSAGE_ID_CREATERESOURCE_CLEARVALUEDENORMFLUSH = 818
D3D12_MESSAGE_ID_CLEARRENDERTARGETVIEW_MISMATCHINGCLEARVALUE = 820
D3D12_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_MISMATCHINGCLEARVALUE = 821
D3D12_MESSAGE_ID_MAP_INVALIDHEAP = 822
D3D12_MESSAGE_ID_UNMAP_INVALIDHEAP = 823
D3D12_MESSAGE_ID_MAP_INVALIDRESOURCE = 824
D3D12_MESSAGE_ID_UNMAP_INVALIDRESOURCE = 825
D3D12_MESSAGE_ID_MAP_INVALIDSUBRESOURCE = 826
D3D12_MESSAGE_ID_UNMAP_INVALIDSUBRESOURCE = 827
D3D12_MESSAGE_ID_MAP_INVALIDRANGE = 828
D3D12_MESSAGE_ID_UNMAP_INVALIDRANGE = 829
D3D12_MESSAGE_ID_MAP_INVALIDDATAPOINTER = 832
D3D12_MESSAGE_ID_MAP_INVALIDARG_RETURN = 833
D3D12_MESSAGE_ID_MAP_OUTOFMEMORY_RETURN = 834
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_BUNDLENOTSUPPORTED = 835
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_COMMANDLISTMISMATCH = 836
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_OPENCOMMANDLIST = 837
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_FAILEDCOMMANDLIST = 838
D3D12_MESSAGE_ID_COPYBUFFERREGION_NULLDST = 839
D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDDSTRESOURCEDIMENSION = 840
D3D12_MESSAGE_ID_COPYBUFFERREGION_DSTRANGEOUTOFBOUNDS = 841
D3D12_MESSAGE_ID_COPYBUFFERREGION_NULLSRC = 842
D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDSRCRESOURCEDIMENSION = 843
D3D12_MESSAGE_ID_COPYBUFFERREGION_SRCRANGEOUTOFBOUNDS = 844
D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDCOPYFLAGS = 845
D3D12_MESSAGE_ID_COPYTEXTUREREGION_NULLDST = 846
D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDDSTTYPE = 847
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTRESOURCEDIMENSION = 848
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTRESOURCE = 849
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTSUBRESOURCE = 850
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTOFFSET = 851
D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDDSTFORMAT = 852
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTFORMAT = 853
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTDIMENSIONS = 854
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTROWPITCH = 855
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTPLACEMENT = 856
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTDSPLACEDFOOTPRINTFORMAT = 857
D3D12_MESSAGE_ID_COPYTEXTUREREGION_DSTREGIONOUTOFBOUNDS = 858
D3D12_MESSAGE_ID_COPYTEXTUREREGION_NULLSRC = 859
D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDSRCTYPE = 860
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCRESOURCEDIMENSION = 861
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCRESOURCE = 862
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCSUBRESOURCE = 863
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCOFFSET = 864
D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDSRCFORMAT = 865
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCFORMAT = 866
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCDIMENSIONS = 867
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCROWPITCH = 868
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCPLACEMENT = 869
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCDSPLACEDFOOTPRINTFORMAT = 870
D3D12_MESSAGE_ID_COPYTEXTUREREGION_SRCREGIONOUTOFBOUNDS = 871
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTCOORDINATES = 872
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCBOX = 873
D3D12_MESSAGE_ID_COPYTEXTUREREGION_FORMATMISMATCH = 874
D3D12_MESSAGE_ID_COPYTEXTUREREGION_EMPTYBOX = 875
D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDCOPYFLAGS = 876
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_SUBRESOURCE_INDEX = 877
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_FORMAT = 878
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_RESOURCE_MISMATCH = 879
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_SAMPLE_COUNT = 880
D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_INVALID_SHADER = 881
D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_CS_ROOT_SIGNATURE_MISMATCH = 882
D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_MISSING_ROOT_SIGNATURE = 883
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALIDCACHEDBLOB = 884
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBADAPTERMISMATCH = 885
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBDRIVERVERSIONMISMATCH = 886
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBDESCMISMATCH = 887
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBIGNORED = 888
D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDHEAP = 889
D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDRESOURCE = 890
D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDBOX = 891
D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDSUBRESOURCE = 892
D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_EMPTYBOX = 893
D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDHEAP = 894
D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDRESOURCE = 895
D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDBOX = 896
D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDSUBRESOURCE = 897
D3D12_MESSAGE_ID_READFROMSUBRESOURCE_EMPTYBOX = 898
D3D12_MESSAGE_ID_TOO_MANY_NODES_SPECIFIED = 899
D3D12_MESSAGE_ID_INVALID_NODE_INDEX = 900
D3D12_MESSAGE_ID_GETHEAPPROPERTIES_INVALIDRESOURCE = 901
D3D12_MESSAGE_ID_NODE_MASK_MISMATCH = 902
D3D12_MESSAGE_ID_COMMAND_LIST_OUTOFMEMORY = 903
D3D12_MESSAGE_ID_COMMAND_LIST_MULTIPLE_SWAPCHAIN_BUFFER_REFERENCES = 904
D3D12_MESSAGE_ID_COMMAND_LIST_TOO_MANY_SWAPCHAIN_REFERENCES = 905
D3D12_MESSAGE_ID_COMMAND_QUEUE_TOO_MANY_SWAPCHAIN_REFERENCES = 906
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_WRONGSWAPCHAINBUFFERREFERENCE = 907
D3D12_MESSAGE_ID_COMMAND_LIST_SETRENDERTARGETS_INVALIDNUMRENDERTARGETS = 908
D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_TYPE = 909
D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_FLAGS = 910
D3D12_MESSAGE_ID_CREATESHAREDRESOURCE_INVALIDFLAGS = 911
D3D12_MESSAGE_ID_CREATESHAREDRESOURCE_INVALIDFORMAT = 912
D3D12_MESSAGE_ID_CREATESHAREDHEAP_INVALIDFLAGS = 913
D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_UNRECOGNIZEDPROPERTIES = 914
D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_INVALIDSIZE = 915
D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_INVALIDOBJECT = 916
D3D12_MESSAGE_ID_KEYEDMUTEX_INVALIDOBJECT = 917
D3D12_MESSAGE_ID_KEYEDMUTEX_INVALIDKEY = 918
D3D12_MESSAGE_ID_KEYEDMUTEX_WRONGSTATE = 919
D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_PRIORITY = 920
D3D12_MESSAGE_ID_OBJECT_DELETED_WHILE_STILL_IN_USE = 921
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALID_FLAGS = 922
D3D12_MESSAGE_ID_HEAP_ADDRESS_RANGE_HAS_NO_RESOURCE = 923
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_RENDER_TARGET_DELETED = 924
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_ALL_RENDER_TARGETS_HAVE_UNKNOWN_FORMAT = 925
D3D12_MESSAGE_ID_HEAP_ADDRESS_RANGE_INTERSECTS_MULTIPLE_BUFFERS = 926
D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_GPU_WRITTEN_READBACK_RESOURCE_MAPPED = 927
D3D12_MESSAGE_ID_UNMAP_RANGE_NOT_EMPTY = 929
D3D12_MESSAGE_ID_MAP_INVALID_NULLRANGE = 930
D3D12_MESSAGE_ID_UNMAP_INVALID_NULLRANGE = 931
D3D12_MESSAGE_ID_NO_GRAPHICS_API_SUPPORT = 932
D3D12_MESSAGE_ID_NO_COMPUTE_API_SUPPORT = 933
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_RESOURCE_FLAGS_NOT_SUPPORTED = 934
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_ROOT_ARGUMENT_UNINITIALIZED = 935
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_HEAP_INDEX_OUT_OF_BOUNDS = 936
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_TABLE_REGISTER_INDEX_OUT_OF_BOUNDS = 937
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_UNINITIALIZED = 938
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_TYPE_MISMATCH = 939
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_SRV_RESOURCE_DIMENSION_MISMATCH = 940
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_UAV_RESOURCE_DIMENSION_MISMATCH = 941
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_INCOMPATIBLE_RESOURCE_STATE = 942
D3D12_MESSAGE_ID_COPYRESOURCE_NULLDST = 943
D3D12_MESSAGE_ID_COPYRESOURCE_INVALIDDSTRESOURCE = 944
D3D12_MESSAGE_ID_COPYRESOURCE_NULLSRC = 945
D3D12_MESSAGE_ID_COPYRESOURCE_INVALIDSRCRESOURCE = 946
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_NULLDST = 947
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALIDDSTRESOURCE = 948
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_NULLSRC = 949
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALIDSRCRESOURCE = 950
D3D12_MESSAGE_ID_PIPELINE_STATE_TYPE_MISMATCH = 951
D3D12_MESSAGE_ID_COMMAND_LIST_DISPATCH_ROOT_SIGNATURE_NOT_SET = 952
D3D12_MESSAGE_ID_COMMAND_LIST_DISPATCH_ROOT_SIGNATURE_MISMATCH = 953
D3D12_MESSAGE_ID_RESOURCE_BARRIER_ZERO_BARRIERS = 954
D3D12_MESSAGE_ID_BEGIN_END_EVENT_MISMATCH = 955
D3D12_MESSAGE_ID_RESOURCE_BARRIER_POSSIBLE_BEFORE_AFTER_MISMATCH = 956
D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_BEGIN_END = 957
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_INVALID_RESOURCE = 958
D3D12_MESSAGE_ID_USE_OF_ZERO_REFCOUNT_OBJECT = 959
D3D12_MESSAGE_ID_OBJECT_EVICTED_WHILE_STILL_IN_USE = 960
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_ROOT_DESCRIPTOR_ACCESS_OUT_OF_BOUNDS = 961
D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_INVALIDLIBRARYBLOB = 962
D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_DRIVERVERSIONMISMATCH = 963
D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_ADAPTERVERSIONMISMATCH = 964
D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_UNSUPPORTED = 965
D3D12_MESSAGE_ID_CREATE_PIPELINELIBRARY = 966
D3D12_MESSAGE_ID_LIVE_PIPELINELIBRARY = 967
D3D12_MESSAGE_ID_DESTROY_PIPELINELIBRARY = 968
D3D12_MESSAGE_ID_STOREPIPELINE_NONAME = 969
D3D12_MESSAGE_ID_STOREPIPELINE_DUPLICATENAME = 970
D3D12_MESSAGE_ID_LOADPIPELINE_NAMENOTFOUND = 971
D3D12_MESSAGE_ID_LOADPIPELINE_INVALIDDESC = 972
D3D12_MESSAGE_ID_PIPELINELIBRARY_SERIALIZE_NOTENOUGHMEMORY = 973
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_OUTPUT_RT_OUTPUT_MISMATCH = 974
D3D12_MESSAGE_ID_SETEVENTONMULTIPLEFENCECOMPLETION_INVALIDFLAGS = 975
D3D12_MESSAGE_ID_CREATE_QUEUE_VIDEO_NOT_SUPPORTED = 976
D3D12_MESSAGE_ID_CREATE_COMMAND_ALLOCATOR_VIDEO_NOT_SUPPORTED = 977
D3D12_MESSAGE_ID_CREATEQUERY_HEAP_VIDEO_DECODE_STATISTICS_NOT_SUPPORTED = 978
D3D12_MESSAGE_ID_CREATE_VIDEODECODECOMMANDLIST = 979
D3D12_MESSAGE_ID_CREATE_VIDEODECODER = 980
D3D12_MESSAGE_ID_CREATE_VIDEODECODESTREAM = 981
D3D12_MESSAGE_ID_LIVE_VIDEODECODECOMMANDLIST = 982
D3D12_MESSAGE_ID_LIVE_VIDEODECODER = 983
D3D12_MESSAGE_ID_LIVE_VIDEODECODESTREAM = 984
D3D12_MESSAGE_ID_DESTROY_VIDEODECODECOMMANDLIST = 985
D3D12_MESSAGE_ID_DESTROY_VIDEODECODER = 986
D3D12_MESSAGE_ID_DESTROY_VIDEODECODESTREAM = 987
D3D12_MESSAGE_ID_DECODE_FRAME_INVALID_PARAMETERS = 988
D3D12_MESSAGE_ID_DEPRECATED_API = 989
D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_COMMAND_LIST_TYPE = 990
D3D12_MESSAGE_ID_COMMAND_LIST_DESCRIPTOR_TABLE_NOT_SET = 991
D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_CONSTANT_BUFFER_VIEW_NOT_SET = 992
D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_SHADER_RESOURCE_VIEW_NOT_SET = 993
D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_UNORDERED_ACCESS_VIEW_NOT_SET = 994
D3D12_MESSAGE_ID_DISCARD_INVALID_SUBRESOURCE_RANGE = 995
D3D12_MESSAGE_ID_DISCARD_ONE_SUBRESOURCE_FOR_MIPS_WITH_RECTS = 996
D3D12_MESSAGE_ID_DISCARD_NO_RECTS_FOR_NON_TEXTURE2D = 997
D3D12_MESSAGE_ID_COPY_ON_SAME_SUBRESOURCE = 998
D3D12_MESSAGE_ID_SETRESIDENCYPRIORITY_INVALID_PAGEABLE = 999
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_UNSUPPORTED = 1000
D3D12_MESSAGE_ID_STATIC_DESCRIPTOR_INVALID_DESCRIPTOR_CHANGE = 1001
D3D12_MESSAGE_ID_DATA_STATIC_DESCRIPTOR_INVALID_DATA_CHANGE = 1002
D3D12_MESSAGE_ID_DATA_STATIC_WHILE_SET_AT_EXECUTE_DESCRIPTOR_INVALID_DATA_CHANGE = 1003
D3D12_MESSAGE_ID_EXECUTE_BUNDLE_STATIC_DESCRIPTOR_DATA_STATIC_NOT_SET = 1004
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_RESOURCE_ACCESS_OUT_OF_BOUNDS = 1005
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_SAMPLER_MODE_MISMATCH = 1006
D3D12_MESSAGE_ID_CREATE_FENCE_INVALID_FLAGS = 1007
D3D12_MESSAGE_ID_RESOURCE_BARRIER_DUPLICATE_SUBRESOURCE_TRANSITIONS = 1008
D3D12_MESSAGE_ID_SETRESIDENCYPRIORITY_INVALID_PRIORITY = 1009
D3D12_MESSAGE_ID_CREATE_DESCRIPTOR_HEAP_LARGE_NUM_DESCRIPTORS = 1013
D3D12_MESSAGE_ID_BEGIN_EVENT = 1014
D3D12_MESSAGE_ID_END_EVENT = 1015
D3D12_MESSAGE_ID_CREATEDEVICE_DEBUG_LAYER_STARTUP_OPTIONS = 1016
D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_DEPTHBOUNDSTEST_UNSUPPORTED = 1017
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_DUPLICATE_SUBOBJECT = 1018
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_UNKNOWN_SUBOBJECT = 1019
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_ZERO_SIZE_STREAM = 1020
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALID_STREAM = 1021
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CANNOT_DEDUCE_TYPE = 1022
D3D12_MESSAGE_ID_COMMAND_LIST_STATIC_DESCRIPTOR_RESOURCE_DIMENSION_MISMATCH = 1023
D3D12_MESSAGE_ID_CREATE_COMMAND_QUEUE_INSUFFICIENT_PRIVILEGE_FOR_GLOBAL_REALTIME = 1024
D3D12_MESSAGE_ID_CREATE_COMMAND_QUEUE_INSUFFICIENT_HARDWARE_SUPPORT_FOR_GLOBAL_REALTIME = 1025
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_ARCHITECTURE = 1026
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DST = 1027
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DST_RESOURCE_DIMENSION = 1028
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DST_RANGE_OUT_OF_BOUNDS = 1029
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_SRC = 1030
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_SRC_RESOURCE_DIMENSION = 1031
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_SRC_RANGE_OUT_OF_BOUNDS = 1032
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_OFFSET_ALIGNMENT = 1033
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DEPENDENT_RESOURCES = 1034
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DEPENDENT_SUBRESOURCE_RANGES = 1035
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DEPENDENT_RESOURCE = 1036
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DEPENDENT_SUBRESOURCE_RANGE = 1037
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DEPENDENT_SUBRESOURCE_OUT_OF_BOUNDS = 1038
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DEPENDENT_RANGE_OUT_OF_BOUNDS = 1039
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_ZERO_DEPENDENCIES = 1040
D3D12_MESSAGE_ID_DEVICE_CREATE_SHARED_HANDLE_INVALIDARG = 1041
D3D12_MESSAGE_ID_DESCRIPTOR_HANDLE_WITH_INVALID_RESOURCE = 1042
D3D12_MESSAGE_ID_SETDEPTHBOUNDS_INVALIDARGS = 1043
D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_RESOURCE_STATE_IMPRECISE = 1044
D3D12_MESSAGE_ID_COMMAND_LIST_PIPELINE_STATE_NOT_SET = 1045
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_MODEL_MISMATCH = 1046
D3D12_MESSAGE_ID_OBJECT_ACCESSED_WHILE_STILL_IN_USE = 1047
D3D12_MESSAGE_ID_PROGRAMMABLE_MSAA_UNSUPPORTED = 1048
D3D12_MESSAGE_ID_SETSAMPLEPOSITIONS_INVALIDARGS = 1049
D3D12_MESSAGE_ID_RESOLVESUBRESOURCEREGION_INVALID_RECT = 1050
D3D12_MESSAGE_ID_CREATE_VIDEODECODECOMMANDQUEUE = 1051
D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSCOMMANDLIST = 1052
D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSCOMMANDQUEUE = 1053
D3D12_MESSAGE_ID_LIVE_VIDEODECODECOMMANDQUEUE = 1054
D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSCOMMANDLIST = 1055
D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSCOMMANDQUEUE = 1056
D3D12_MESSAGE_ID_DESTROY_VIDEODECODECOMMANDQUEUE = 1057
D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSCOMMANDLIST = 1058
D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSCOMMANDQUEUE = 1059
D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSOR = 1060
D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSSTREAM = 1061
D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSOR = 1062
D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSSTREAM = 1063
D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSOR = 1064
D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSSTREAM = 1065
D3D12_MESSAGE_ID_PROCESS_FRAME_INVALID_PARAMETERS = 1066
D3D12_MESSAGE_ID_COPY_INVALIDLAYOUT = 1067
D3D12_MESSAGE_ID_CREATE_CRYPTO_SESSION = 1068
D3D12_MESSAGE_ID_CREATE_CRYPTO_SESSION_POLICY = 1069
D3D12_MESSAGE_ID_CREATE_PROTECTED_RESOURCE_SESSION = 1070
D3D12_MESSAGE_ID_LIVE_CRYPTO_SESSION = 1071
D3D12_MESSAGE_ID_LIVE_CRYPTO_SESSION_POLICY = 1072
D3D12_MESSAGE_ID_LIVE_PROTECTED_RESOURCE_SESSION = 1073
D3D12_MESSAGE_ID_DESTROY_CRYPTO_SESSION = 1074
D3D12_MESSAGE_ID_DESTROY_CRYPTO_SESSION_POLICY = 1075
D3D12_MESSAGE_ID_DESTROY_PROTECTED_RESOURCE_SESSION = 1076
D3D12_MESSAGE_ID_PROTECTED_RESOURCE_SESSION_UNSUPPORTED = 1077
D3D12_MESSAGE_ID_FENCE_INVALIDOPERATION = 1078
D3D12_MESSAGE_ID_CREATEQUERY_HEAP_COPY_QUEUE_TIMESTAMPS_NOT_SUPPORTED = 1079
D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_DEFERRED = 1080
D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_RECORDTIME_ASSUMEDFROMFIRSTUSE = 1081
D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_RECORDTIME_ASSUMEDFROMCLEAR = 1082
D3D12_MESSAGE_ID_CREATE_VIDEODECODERHEAP = 1083
D3D12_MESSAGE_ID_LIVE_VIDEODECODERHEAP = 1084
D3D12_MESSAGE_ID_DESTROY_VIDEODECODERHEAP = 1085
D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDARG_RETURN = 1086
D3D12_MESSAGE_ID_OPENEXISTINGHEAP_OUTOFMEMORY_RETURN = 1087
D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDADDRESS = 1088
D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDHANDLE = 1089
D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_DEST = 1090
D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_MODE = 1091
D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_ALIGNMENT = 1092
D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_NOT_SUPPORTED = 1093
D3D12_MESSAGE_ID_SETVIEWINSTANCEMASK_INVALIDARGS = 1094
D3D12_MESSAGE_ID_VIEW_INSTANCING_UNSUPPORTED = 1095
D3D12_MESSAGE_ID_VIEW_INSTANCING_INVALIDARGS = 1096
D3D12_MESSAGE_ID_COPYTEXTUREREGION_MISMATCH_DECODE_REFERENCE_ONLY_FLAG = 1097
D3D12_MESSAGE_ID_COPYRESOURCE_MISMATCH_DECODE_REFERENCE_ONLY_FLAG = 1098
D3D12_MESSAGE_ID_CREATE_VIDEO_DECODE_HEAP_CAPS_FAILURE = 1099
D3D12_MESSAGE_ID_CREATE_VIDEO_DECODE_HEAP_CAPS_UNSUPPORTED = 1100
D3D12_MESSAGE_ID_VIDEO_DECODE_SUPPORT_INVALID_INPUT = 1101
D3D12_MESSAGE_ID_CREATE_VIDEO_DECODER_UNSUPPORTED = 1102
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_METADATA_ERROR = 1103
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VIEW_INSTANCING_VERTEX_SIZE_EXCEEDED = 1104
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RUNTIME_INTERNAL_ERROR = 1105
D3D12_MESSAGE_ID_NO_VIDEO_API_SUPPORT = 1106
D3D12_MESSAGE_ID_VIDEO_PROCESS_SUPPORT_INVALID_INPUT = 1107
D3D12_MESSAGE_ID_CREATE_VIDEO_PROCESSOR_CAPS_FAILURE = 1108
D3D12_MESSAGE_ID_VIDEO_PROCESS_SUPPORT_UNSUPPORTED_FORMAT = 1109
D3D12_MESSAGE_ID_VIDEO_DECODE_FRAME_INVALID_ARGUMENT = 1110
D3D12_MESSAGE_ID_ENQUEUE_MAKE_RESIDENT_INVALID_FLAGS = 1111
D3D12_MESSAGE_ID_OPENEXISTINGHEAP_UNSUPPORTED = 1112
D3D12_MESSAGE_ID_VIDEO_PROCESS_FRAMES_INVALID_ARGUMENT = 1113
D3D12_MESSAGE_ID_VIDEO_DECODE_SUPPORT_UNSUPPORTED = 1114
D3D12_MESSAGE_ID_CREATE_COMMANDRECORDER = 1115
D3D12_MESSAGE_ID_LIVE_COMMANDRECORDER = 1116
D3D12_MESSAGE_ID_DESTROY_COMMANDRECORDER = 1117
D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_VIDEO_NOT_SUPPORTED = 1118
D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_INVALID_SUPPORT_FLAGS = 1119
D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_INVALID_FLAGS = 1120
D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_MORE_RECORDERS_THAN_LOGICAL_PROCESSORS = 1121
D3D12_MESSAGE_ID_CREATE_COMMANDPOOL = 1122
D3D12_MESSAGE_ID_LIVE_COMMANDPOOL = 1123
D3D12_MESSAGE_ID_DESTROY_COMMANDPOOL = 1124
D3D12_MESSAGE_ID_CREATE_COMMAND_POOL_INVALID_FLAGS = 1125
D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_VIDEO_NOT_SUPPORTED = 1126
D3D12_MESSAGE_ID_COMMAND_RECORDER_SUPPORT_FLAGS_MISMATCH = 1127
D3D12_MESSAGE_ID_COMMAND_RECORDER_CONTENTION = 1128
D3D12_MESSAGE_ID_COMMAND_RECORDER_USAGE_WITH_CREATECOMMANDLIST_COMMAND_LIST = 1129
D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_USAGE_WITH_CREATECOMMANDLIST1_COMMAND_LIST = 1130
D3D12_MESSAGE_ID_CANNOT_EXECUTE_EMPTY_COMMAND_LIST = 1131
D3D12_MESSAGE_ID_CANNOT_RESET_COMMAND_POOL_WITH_OPEN_COMMAND_LISTS = 1132
D3D12_MESSAGE_ID_CANNOT_USE_COMMAND_RECORDER_WITHOUT_CURRENT_TARGET = 1133
D3D12_MESSAGE_ID_CANNOT_CHANGE_COMMAND_RECORDER_TARGET_WHILE_RECORDING = 1134
D3D12_MESSAGE_ID_COMMAND_POOL_SYNC = 1135
D3D12_MESSAGE_ID_EVICT_UNDERFLOW = 1136
D3D12_MESSAGE_ID_CREATE_META_COMMAND = 1137
D3D12_MESSAGE_ID_LIVE_META_COMMAND = 1138
D3D12_MESSAGE_ID_DESTROY_META_COMMAND = 1139
D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALID_DST_RESOURCE = 1140
D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALID_SRC_RESOURCE = 1141
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DST_RESOURCE = 1142
D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_SRC_RESOURCE = 1143
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_NULL_BUFFER = 1144
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_NULL_RESOURCE_DESC = 1145
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_UNSUPPORTED = 1146
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_DIMENSION = 1147
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_FLAGS = 1148
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_OFFSET = 1149
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_RESOURCE_DIMENSION = 1150
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_RESOURCE_FLAGS = 1151
D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_OUTOFMEMORY_RETURN = 1152
D3D12_MESSAGE_ID_CANNOT_CREATE_GRAPHICS_AND_VIDEO_COMMAND_RECORDER = 1153
D3D12_MESSAGE_ID_UPDATETILEMAPPINGS_POSSIBLY_MISMATCHING_PROPERTIES = 1154
D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_INVALID_COMMAND_LIST_TYPE = 1155
D3D12_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_INCOMPATIBLE_WITH_STRUCTURED_BUFFERS = 1156
D3D12_MESSAGE_ID_COMPUTE_ONLY_DEVICE_OPERATION_UNSUPPORTED = 1157
D3D12_MESSAGE_ID_BUILD_RAYTRACING_ACCELERATION_STRUCTURE_INVALID = 1158
D3D12_MESSAGE_ID_EMIT_RAYTRACING_ACCELERATION_STRUCTURE_POSTBUILD_INFO_INVALID = 1159
D3D12_MESSAGE_ID_COPY_RAYTRACING_ACCELERATION_STRUCTURE_INVALID = 1160
D3D12_MESSAGE_ID_DISPATCH_RAYS_INVALID = 1161
D3D12_MESSAGE_ID_GET_RAYTRACING_ACCELERATION_STRUCTURE_PREBUILD_INFO_INVALID = 1162
D3D12_MESSAGE_ID_CREATE_LIFETIMETRACKER = 1163
D3D12_MESSAGE_ID_LIVE_LIFETIMETRACKER = 1164
D3D12_MESSAGE_ID_DESTROY_LIFETIMETRACKER = 1165
D3D12_MESSAGE_ID_DESTROYOWNEDOBJECT_OBJECTNOTOWNED = 1166
D3D12_MESSAGE_ID_CREATE_TRACKEDWORKLOAD = 1167
D3D12_MESSAGE_ID_LIVE_TRACKEDWORKLOAD = 1168
D3D12_MESSAGE_ID_DESTROY_TRACKEDWORKLOAD = 1169
D3D12_MESSAGE_ID_RENDER_PASS_ERROR = 1170
D3D12_MESSAGE_ID_META_COMMAND_ID_INVALID = 1171
D3D12_MESSAGE_ID_META_COMMAND_UNSUPPORTED_PARAMS = 1172
D3D12_MESSAGE_ID_META_COMMAND_FAILED_ENUMERATION = 1173
D3D12_MESSAGE_ID_META_COMMAND_PARAMETER_SIZE_MISMATCH = 1174
D3D12_MESSAGE_ID_UNINITIALIZED_META_COMMAND = 1175
D3D12_MESSAGE_ID_META_COMMAND_INVALID_GPU_VIRTUAL_ADDRESS = 1176
D3D12_MESSAGE_ID_CREATE_VIDEOENCODECOMMANDLIST = 1177
D3D12_MESSAGE_ID_LIVE_VIDEOENCODECOMMANDLIST = 1178
D3D12_MESSAGE_ID_DESTROY_VIDEOENCODECOMMANDLIST = 1179
D3D12_MESSAGE_ID_CREATE_VIDEOENCODECOMMANDQUEUE = 1180
D3D12_MESSAGE_ID_LIVE_VIDEOENCODECOMMANDQUEUE = 1181
D3D12_MESSAGE_ID_DESTROY_VIDEOENCODECOMMANDQUEUE = 1182
D3D12_MESSAGE_ID_CREATE_VIDEOMOTIONESTIMATOR = 1183
D3D12_MESSAGE_ID_LIVE_VIDEOMOTIONESTIMATOR = 1184
D3D12_MESSAGE_ID_DESTROY_VIDEOMOTIONESTIMATOR = 1185
D3D12_MESSAGE_ID_CREATE_VIDEOMOTIONVECTORHEAP = 1186
D3D12_MESSAGE_ID_LIVE_VIDEOMOTIONVECTORHEAP = 1187
D3D12_MESSAGE_ID_DESTROY_VIDEOMOTIONVECTORHEAP = 1188
D3D12_MESSAGE_ID_MULTIPLE_TRACKED_WORKLOADS = 1189
D3D12_MESSAGE_ID_MULTIPLE_TRACKED_WORKLOAD_PAIRS = 1190
D3D12_MESSAGE_ID_OUT_OF_ORDER_TRACKED_WORKLOAD_PAIR = 1191
D3D12_MESSAGE_ID_CANNOT_ADD_TRACKED_WORKLOAD = 1192
D3D12_MESSAGE_ID_INCOMPLETE_TRACKED_WORKLOAD_PAIR = 1193
D3D12_MESSAGE_ID_CREATE_STATE_OBJECT_ERROR = 1194
D3D12_MESSAGE_ID_GET_SHADER_IDENTIFIER_ERROR = 1195
D3D12_MESSAGE_ID_GET_SHADER_STACK_SIZE_ERROR = 1196
D3D12_MESSAGE_ID_GET_PIPELINE_STACK_SIZE_ERROR = 1197
D3D12_MESSAGE_ID_SET_PIPELINE_STACK_SIZE_ERROR = 1198
D3D12_MESSAGE_ID_GET_SHADER_IDENTIFIER_SIZE_INVALID = 1199
D3D12_MESSAGE_ID_CHECK_DRIVER_MATCHING_IDENTIFIER_INVALID = 1200
D3D12_MESSAGE_ID_CHECK_DRIVER_MATCHING_IDENTIFIER_DRIVER_REPORTED_ISSUE = 1201
D3D12_MESSAGE_ID_RENDER_PASS_INVALID_RESOURCE_BARRIER = 1202
D3D12_MESSAGE_ID_RENDER_PASS_DISALLOWED_API_CALLED = 1203
D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_NEST_RENDER_PASSES = 1204
D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_END_WITHOUT_BEGIN = 1205
D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_CLOSE_COMMAND_LIST = 1206
D3D12_MESSAGE_ID_RENDER_PASS_GPU_WORK_WHILE_SUSPENDED = 1207
D3D12_MESSAGE_ID_RENDER_PASS_MISMATCHING_SUSPEND_RESUME = 1208
D3D12_MESSAGE_ID_RENDER_PASS_NO_PRIOR_SUSPEND_WITHIN_EXECUTECOMMANDLISTS = 1209
D3D12_MESSAGE_ID_RENDER_PASS_NO_SUBSEQUENT_RESUME_WITHIN_EXECUTECOMMANDLISTS = 1210
D3D12_MESSAGE_ID_TRACKED_WORKLOAD_COMMAND_QUEUE_MISMATCH = 1211
D3D12_MESSAGE_ID_TRACKED_WORKLOAD_NOT_SUPPORTED = 1212
D3D12_MESSAGE_ID_RENDER_PASS_MISMATCHING_NO_ACCESS = 1213
D3D12_MESSAGE_ID_RENDER_PASS_UNSUPPORTED_RESOLVE = 1214
D3D12_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_INVALID_RESOURCE_PTR = 1215
D3D12_MESSAGE_ID_WINDOWS7_FENCE_OUTOFORDER_SIGNAL = 1216
D3D12_MESSAGE_ID_WINDOWS7_FENCE_OUTOFORDER_WAIT = 1217
D3D12_MESSAGE_ID_VIDEO_CREATE_MOTION_ESTIMATOR_INVALID_ARGUMENT = 1218
D3D12_MESSAGE_ID_VIDEO_CREATE_MOTION_VECTOR_HEAP_INVALID_ARGUMENT = 1219
D3D12_MESSAGE_ID_ESTIMATE_MOTION_INVALID_ARGUMENT = 1220
D3D12_MESSAGE_ID_RESOLVE_MOTION_VECTOR_HEAP_INVALID_ARGUMENT = 1221
D3D12_MESSAGE_ID_GETGPUVIRTUALADDRESS_INVALID_HEAP_TYPE = 1222
D3D12_MESSAGE_ID_SET_BACKGROUND_PROCESSING_MODE_INVALID_ARGUMENT = 1223
D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_INVALID_COMMAND_LIST_TYPE_FOR_FEATURE_LEVEL = 1224
D3D12_MESSAGE_ID_CREATE_VIDEOEXTENSIONCOMMAND = 1225
D3D12_MESSAGE_ID_LIVE_VIDEOEXTENSIONCOMMAND = 1226
D3D12_MESSAGE_ID_DESTROY_VIDEOEXTENSIONCOMMAND = 1227
D3D12_MESSAGE_ID_INVALID_VIDEO_EXTENSION_COMMAND_ID = 1228
D3D12_MESSAGE_ID_VIDEO_EXTENSION_COMMAND_INVALID_ARGUMENT = 1229
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_NOT_UNIQUE_IN_DXIL_LIBRARY = 1230
D3D12_MESSAGE_ID_VARIABLE_SHADING_RATE_NOT_ALLOWED_WITH_TIR = 1231
D3D12_MESSAGE_ID_GEOMETRY_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE = 1232
D3D12_MESSAGE_ID_RSSETSHADING_RATE_INVALID_SHADING_RATE = 1233
D3D12_MESSAGE_ID_RSSETSHADING_RATE_SHADING_RATE_NOT_PERMITTED_BY_CAP = 1234
D3D12_MESSAGE_ID_RSSETSHADING_RATE_INVALID_COMBINER = 1235
D3D12_MESSAGE_ID_RSSETSHADINGRATEIMAGE_REQUIRES_TIER_2 = 1236
D3D12_MESSAGE_ID_RSSETSHADINGRATE_REQUIRES_TIER_1 = 1237
D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_FORMAT = 1238
D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_ARRAY_SIZE = 1239
D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_MIP_LEVEL = 1240
D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_SAMPLE_COUNT = 1241
D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_SAMPLE_QUALITY = 1242
D3D12_MESSAGE_ID_NON_RETAIL_SHADER_MODEL_WONT_VALIDATE = 1243
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_AS_ROOT_SIGNATURE_MISMATCH = 1244
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_ROOT_SIGNATURE_MISMATCH = 1245
D3D12_MESSAGE_ID_ADD_TO_STATE_OBJECT_ERROR = 1246
D3D12_MESSAGE_ID_CREATE_PROTECTED_RESOURCE_SESSION_INVALID_ARGUMENT = 1247
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_PSO_DESC_MISMATCH = 1248
D3D12_MESSAGE_ID_CREATEPIPELINESTATE_MS_INCOMPLETE_TYPE = 1249
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_AS_NOT_MS_MISMATCH = 1250
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_NOT_PS_MISMATCH = 1251
D3D12_MESSAGE_ID_NONZERO_SAMPLER_FEEDBACK_MIP_REGION_WITH_INCOMPATIBLE_FORMAT = 1252
D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INPUTLAYOUT_SHADER_MISMATCH = 1253
D3D12_MESSAGE_ID_EMPTY_DISPATCH = 1254
D3D12_MESSAGE_ID_RESOURCE_FORMAT_REQUIRES_SAMPLER_FEEDBACK_CAPABILITY = 1255
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_MIP_REGION = 1256
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_DIMENSION = 1257
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_SAMPLE_COUNT = 1258
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_SAMPLE_QUALITY = 1259
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_LAYOUT = 1260
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_REQUIRES_UNORDERED_ACCESS_FLAG = 1261
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_NULL_ARGUMENTS = 1262
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_UAV_REQUIRES_SAMPLER_FEEDBACK_CAPABILITY = 1263
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_REQUIRES_FEEDBACK_MAP_FORMAT = 1264
D3D12_MESSAGE_ID_CREATEMESHSHADER_INVALIDSHADERBYTECODE = 1265
D3D12_MESSAGE_ID_CREATEMESHSHADER_OUTOFMEMORY = 1266
D3D12_MESSAGE_ID_CREATEMESHSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE = 1267
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_TRANSCODE_INVALID_FORMAT = 1268
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_INVALID_MIP_LEVEL_COUNT = 1269
D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_TRANSCODE_ARRAY_SIZE_MISMATCH = 1270
D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_MISMATCHING_TARGETED_RESOURCE = 1271
D3D12_MESSAGE_ID_CREATEMESHSHADER_OUTPUTEXCEEDSMAXSIZE = 1272
D3D12_MESSAGE_ID_CREATEMESHSHADER_GROUPSHAREDEXCEEDSMAXSIZE = 1273
D3D12_MESSAGE_ID_VERTEX_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE = 1274
D3D12_MESSAGE_ID_MESH_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE = 1275
D3D12_MESSAGE_ID_CREATEMESHSHADER_MISMATCHEDASMSPAYLOADSIZE = 1276
D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_UNBOUNDED_STATIC_DESCRIPTORS = 1277
D3D12_MESSAGE_ID_CREATEAMPLIFICATIONSHADER_INVALIDSHADERBYTECODE = 1278
D3D12_MESSAGE_ID_CREATEAMPLIFICATIONSHADER_OUTOFMEMORY = 1279
D3D12_MESSAGE_ID_CREATE_SHADERCACHESESSION = 1280
D3D12_MESSAGE_ID_LIVE_SHADERCACHESESSION = 1281
D3D12_MESSAGE_ID_DESTROY_SHADERCACHESESSION = 1282
D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_INVALIDARGS = 1283
D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_DISABLED = 1284
D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_ALREADYOPEN = 1285
D3D12_MESSAGE_ID_SHADERCACHECONTROL_DEVELOPERMODE = 1286
D3D12_MESSAGE_ID_SHADERCACHECONTROL_INVALIDFLAGS = 1287
D3D12_MESSAGE_ID_SHADERCACHECONTROL_STATEALREADYSET = 1288
D3D12_MESSAGE_ID_SHADERCACHECONTROL_IGNOREDFLAG = 1289
D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_ALREADYPRESENT = 1290
D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_HASHCOLLISION = 1291
D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_CACHEFULL = 1292
D3D12_MESSAGE_ID_SHADERCACHESESSION_FINDVALUE_NOTFOUND = 1293
D3D12_MESSAGE_ID_SHADERCACHESESSION_CORRUPT = 1294
D3D12_MESSAGE_ID_SHADERCACHESESSION_DISABLED = 1295
D3D12_MESSAGE_ID_OVERSIZED_DISPATCH = 1296
D3D12_MESSAGE_ID_CREATE_VIDEOENCODER = 1297
D3D12_MESSAGE_ID_LIVE_VIDEOENCODER = 1298
D3D12_MESSAGE_ID_DESTROY_VIDEOENCODER = 1299
D3D12_MESSAGE_ID_CREATE_VIDEOENCODERHEAP = 1300
D3D12_MESSAGE_ID_LIVE_VIDEOENCODERHEAP = 1301
D3D12_MESSAGE_ID_DESTROY_VIDEOENCODERHEAP = 1302
D3D12_MESSAGE_ID_COPYTEXTUREREGION_MISMATCH_ENCODE_REFERENCE_ONLY_FLAG = 1303
D3D12_MESSAGE_ID_COPYRESOURCE_MISMATCH_ENCODE_REFERENCE_ONLY_FLAG = 1304
D3D12_MESSAGE_ID_ENCODE_FRAME_INVALID_PARAMETERS = 1305
D3D12_MESSAGE_ID_ENCODE_FRAME_UNSUPPORTED_PARAMETERS = 1306
D3D12_MESSAGE_ID_RESOLVE_ENCODER_OUTPUT_METADATA_INVALID_PARAMETERS = 1307
D3D12_MESSAGE_ID_RESOLVE_ENCODER_OUTPUT_METADATA_UNSUPPORTED_PARAMETERS = 1308
D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_INVALID_PARAMETERS = 1309
D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_UNSUPPORTED_PARAMETERS = 1310
D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_HEAP_INVALID_PARAMETERS = 1311
D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_HEAP_UNSUPPORTED_PARAMETERS = 1312
D3D12_MESSAGE_ID_CREATECOMMANDLIST_NULL_COMMANDALLOCATOR = 1313
D3D12_MESSAGE_ID_CLEAR_UNORDERED_ACCESS_VIEW_INVALID_DESCRIPTOR_HANDLE = 1314
D3D12_MESSAGE_ID_DESCRIPTOR_HEAP_NOT_SHADER_VISIBLE = 1315
D3D12_MESSAGE_ID_CREATEBLENDSTATE_BLENDOP_WARNING = 1316
D3D12_MESSAGE_ID_CREATEBLENDSTATE_BLENDOPALPHA_WARNING = 1317
D3D12_MESSAGE_ID_WRITE_COMBINE_PERFORMANCE_WARNING = 1318
D3D12_MESSAGE_ID_RESOLVE_QUERY_INVALID_QUERY_STATE = 1319
D3D12_MESSAGE_ID_SETPRIVATEDATA_NO_ACCESS = 1320
D3D12_MESSAGE_ID_COMMAND_LIST_STATIC_DESCRIPTOR_SAMPLER_MODE_MISMATCH = 1321
D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_UNSUPPORTED_BUFFER_WIDTH = 1322
D3D12_MESSAGE_ID_CREATEMESHSHADER_TOPOLOGY_MISMATCH = 1323
D3D12_MESSAGE_ID_VRS_SUM_COMBINER_REQUIRES_CAPABILITY = 1324
D3D12_MESSAGE_ID_SETTING_SHADING_RATE_FROM_MS_REQUIRES_CAPABILITY = 1325
D3D12_MESSAGE_ID_SHADERCACHESESSION_SHADERCACHEDELETE_NOTSUPPORTED = 1326
D3D12_MESSAGE_ID_SHADERCACHECONTROL_SHADERCACHECLEAR_NOTSUPPORTED = 1327
D3D12_MESSAGE_ID_CREATERESOURCE_STATE_IGNORED = 1328
D3D12_MESSAGE_ID_UNUSED_CROSS_EXECUTE_SPLIT_BARRIER = 1329
D3D12_MESSAGE_ID_DEVICE_OPEN_SHARED_HANDLE_ACCESS_DENIED = 1330
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_VALUES = 1331
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_ACCESS = 1332
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_SYNC = 1333
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_LAYOUT = 1334
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_TYPE = 1335
D3D12_MESSAGE_ID_OUT_OF_BOUNDS_BARRIER_SUBRESOURCE_RANGE = 1336
D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_RESOURCE_DIMENSION = 1337
D3D12_MESSAGE_ID_SET_SCISSOR_RECTS_INVALID_RECT = 1338
D3D12_MESSAGE_ID_SHADING_RATE_SOURCE_REQUIRES_DIMENSION_TEXTURE2D = 1339
D3D12_MESSAGE_ID_BUFFER_BARRIER_SUBREGION_OUT_OF_BOUNDS = 1340
D3D12_MESSAGE_ID_UNSUPPORTED_BARRIER_LAYOUT = 1341
D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALID_PARAMETERS = 1342
D3D12_MESSAGE_ID_ENHANCED_BARRIERS_NOT_SUPPORTED = 1343
D3D12_MESSAGE_ID_CAST_TARGET_TEXEL_SIZE_MISMATCH = 1344
D3D12_MESSAGE_ID_CAST_TO_PLANAR_NOT_SUPORTED = 1345
D3D12_MESSAGE_ID_LEGACY_BARRIER_VALIDATION_FORCED_ON = 1346
D3D12_MESSAGE_ID_EMPTY_ROOT_DESCRIPTOR_TABLE = 1347
D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ELEMENT_OFFSET_UNALIGNED = 1348
D3D12_MESSAGE_ID_ALPHA_BLEND_FACTOR_NOT_SUPPORTED = 1349
D3D12_MESSAGE_ID_D3D12_MESSAGES_END = 1350
D3D12_MESSAGE_ID = c_int  # enum

# values for enumeration 'D3D12_GPU_BASED_VALIDATION_FLAGS'
D3D12_GPU_BASED_VALIDATION_FLAGS_NONE = 0
D3D12_GPU_BASED_VALIDATION_FLAGS_DISABLE_STATE_TRACKING = 1
D3D12_GPU_BASED_VALIDATION_FLAGS = c_int  # enum

# values for enumeration 'D3D12_RESOURCE_FLAGS'
D3D12_RESOURCE_FLAG_NONE = 0
D3D12_RESOURCE_FLAG_ALLOW_RENDER_TARGET = 1
D3D12_RESOURCE_FLAG_ALLOW_DEPTH_STENCIL = 2
D3D12_RESOURCE_FLAG_ALLOW_UNORDERED_ACCESS = 4
D3D12_RESOURCE_FLAG_DENY_SHADER_RESOURCE = 8
D3D12_RESOURCE_FLAG_ALLOW_CROSS_ADAPTER = 16
D3D12_RESOURCE_FLAG_ALLOW_SIMULTANEOUS_ACCESS = 32
D3D12_RESOURCE_FLAG_VIDEO_DECODE_REFERENCE_ONLY = 64
D3D12_RESOURCE_FLAG_VIDEO_ENCODE_REFERENCE_ONLY = 128
D3D12_RESOURCE_FLAG_RAYTRACING_ACCELERATION_STRUCTURE = 256
D3D12_RESOURCE_FLAGS = c_int  # enum

# values for enumeration 'D3D12_DEBUG_FEATURE'
D3D12_DEBUG_FEATURE_NONE = 0
D3D12_DEBUG_FEATURE_ALLOW_BEHAVIOR_CHANGING_DEBUG_AIDS = 1
D3D12_DEBUG_FEATURE_CONSERVATIVE_RESOURCE_STATE_TRACKING = 2
D3D12_DEBUG_FEATURE_DISABLE_VIRTUALIZED_BUNDLES_VALIDATION = 4
D3D12_DEBUG_FEATURE_EMULATE_WINDOWS7 = 8
D3D12_DEBUG_FEATURE = c_int  # enum

# values for enumeration 'D3D12_HEAP_TYPE'
D3D12_HEAP_TYPE_DEFAULT = 1
D3D12_HEAP_TYPE_UPLOAD = 2
D3D12_HEAP_TYPE_READBACK = 3
D3D12_HEAP_TYPE_CUSTOM = 4
D3D12_HEAP_TYPE = c_int  # enum

# values for enumeration 'D3D12_MEMORY_POOL'
D3D12_MEMORY_POOL_UNKNOWN = 0
D3D12_MEMORY_POOL_L0 = 1
D3D12_MEMORY_POOL_L1 = 2
D3D12_MEMORY_POOL = c_int  # enum

# values for enumeration 'D3D12_DEBUG_DEVICE_PARAMETER_TYPE'
D3D12_DEBUG_DEVICE_PARAMETER_FEATURE_FLAGS = 0
D3D12_DEBUG_DEVICE_PARAMETER_GPU_BASED_VALIDATION_SETTINGS = 1
D3D12_DEBUG_DEVICE_PARAMETER_GPU_SLOWDOWN_PERFORMANCE_FACTOR = 2
D3D12_DEBUG_DEVICE_PARAMETER_TYPE = c_int  # enum

# values for enumeration 'D3D12_RESOURCE_DIMENSION'
D3D12_RESOURCE_DIMENSION_UNKNOWN = 0
D3D12_RESOURCE_DIMENSION_BUFFER = 1
D3D12_RESOURCE_DIMENSION_TEXTURE1D = 2
D3D12_RESOURCE_DIMENSION_TEXTURE2D = 3
D3D12_RESOURCE_DIMENSION_TEXTURE3D = 4
D3D12_RESOURCE_DIMENSION = c_int  # enum

# values for enumeration 'DXGI_FORMAT'
DXGI_FORMAT_UNKNOWN = 0
DXGI_FORMAT_R32G32B32A32_TYPELESS = 1
DXGI_FORMAT_R32G32B32A32_FLOAT = 2
DXGI_FORMAT_R32G32B32A32_UINT = 3
DXGI_FORMAT_R32G32B32A32_SINT = 4
DXGI_FORMAT_R32G32B32_TYPELESS = 5
DXGI_FORMAT_R32G32B32_FLOAT = 6
DXGI_FORMAT_R32G32B32_UINT = 7
DXGI_FORMAT_R32G32B32_SINT = 8
DXGI_FORMAT_R16G16B16A16_TYPELESS = 9
DXGI_FORMAT_R16G16B16A16_FLOAT = 10
DXGI_FORMAT_R16G16B16A16_UNORM = 11
DXGI_FORMAT_R16G16B16A16_UINT = 12
DXGI_FORMAT_R16G16B16A16_SNORM = 13
DXGI_FORMAT_R16G16B16A16_SINT = 14
DXGI_FORMAT_R32G32_TYPELESS = 15
DXGI_FORMAT_R32G32_FLOAT = 16
DXGI_FORMAT_R32G32_UINT = 17
DXGI_FORMAT_R32G32_SINT = 18
DXGI_FORMAT_R32G8X24_TYPELESS = 19
DXGI_FORMAT_D32_FLOAT_S8X24_UINT = 20
DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS = 21
DXGI_FORMAT_X32_TYPELESS_G8X24_UINT = 22
DXGI_FORMAT_R10G10B10A2_TYPELESS = 23
DXGI_FORMAT_R10G10B10A2_UNORM = 24
DXGI_FORMAT_R10G10B10A2_UINT = 25
DXGI_FORMAT_R11G11B10_FLOAT = 26
DXGI_FORMAT_R8G8B8A8_TYPELESS = 27
DXGI_FORMAT_R8G8B8A8_UNORM = 28
DXGI_FORMAT_R8G8B8A8_UNORM_SRGB = 29
DXGI_FORMAT_R8G8B8A8_UINT = 30
DXGI_FORMAT_R8G8B8A8_SNORM = 31
DXGI_FORMAT_R8G8B8A8_SINT = 32
DXGI_FORMAT_R16G16_TYPELESS = 33
DXGI_FORMAT_R16G16_FLOAT = 34
DXGI_FORMAT_R16G16_UNORM = 35
DXGI_FORMAT_R16G16_UINT = 36
DXGI_FORMAT_R16G16_SNORM = 37
DXGI_FORMAT_R16G16_SINT = 38
DXGI_FORMAT_R32_TYPELESS = 39
DXGI_FORMAT_D32_FLOAT = 40
DXGI_FORMAT_R32_FLOAT = 41
DXGI_FORMAT_R32_UINT = 42
DXGI_FORMAT_R32_SINT = 43
DXGI_FORMAT_R24G8_TYPELESS = 44
DXGI_FORMAT_D24_UNORM_S8_UINT = 45
DXGI_FORMAT_R24_UNORM_X8_TYPELESS = 46
DXGI_FORMAT_X24_TYPELESS_G8_UINT = 47
DXGI_FORMAT_R8G8_TYPELESS = 48
DXGI_FORMAT_R8G8_UNORM = 49
DXGI_FORMAT_R8G8_UINT = 50
DXGI_FORMAT_R8G8_SNORM = 51
DXGI_FORMAT_R8G8_SINT = 52
DXGI_FORMAT_R16_TYPELESS = 53
DXGI_FORMAT_R16_FLOAT = 54
DXGI_FORMAT_D16_UNORM = 55
DXGI_FORMAT_R16_UNORM = 56
DXGI_FORMAT_R16_UINT = 57
DXGI_FORMAT_R16_SNORM = 58
DXGI_FORMAT_R16_SINT = 59
DXGI_FORMAT_R8_TYPELESS = 60
DXGI_FORMAT_R8_UNORM = 61
DXGI_FORMAT_R8_UINT = 62
DXGI_FORMAT_R8_SNORM = 63
DXGI_FORMAT_R8_SINT = 64
DXGI_FORMAT_A8_UNORM = 65
DXGI_FORMAT_R1_UNORM = 66
DXGI_FORMAT_R9G9B9E5_SHAREDEXP = 67
DXGI_FORMAT_R8G8_B8G8_UNORM = 68
DXGI_FORMAT_G8R8_G8B8_UNORM = 69
DXGI_FORMAT_BC1_TYPELESS = 70
DXGI_FORMAT_BC1_UNORM = 71
DXGI_FORMAT_BC1_UNORM_SRGB = 72
DXGI_FORMAT_BC2_TYPELESS = 73
DXGI_FORMAT_BC2_UNORM = 74
DXGI_FORMAT_BC2_UNORM_SRGB = 75
DXGI_FORMAT_BC3_TYPELESS = 76
DXGI_FORMAT_BC3_UNORM = 77
DXGI_FORMAT_BC3_UNORM_SRGB = 78
DXGI_FORMAT_BC4_TYPELESS = 79
DXGI_FORMAT_BC4_UNORM = 80
DXGI_FORMAT_BC4_SNORM = 81
DXGI_FORMAT_BC5_TYPELESS = 82
DXGI_FORMAT_BC5_UNORM = 83
DXGI_FORMAT_BC5_SNORM = 84
DXGI_FORMAT_B5G6R5_UNORM = 85
DXGI_FORMAT_B5G5R5A1_UNORM = 86
DXGI_FORMAT_B8G8R8A8_UNORM = 87
DXGI_FORMAT_B8G8R8X8_UNORM = 88
DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM = 89
DXGI_FORMAT_B8G8R8A8_TYPELESS = 90
DXGI_FORMAT_B8G8R8A8_UNORM_SRGB = 91
DXGI_FORMAT_B8G8R8X8_TYPELESS = 92
DXGI_FORMAT_B8G8R8X8_UNORM_SRGB = 93
DXGI_FORMAT_BC6H_TYPELESS = 94
DXGI_FORMAT_BC6H_UF16 = 95
DXGI_FORMAT_BC6H_SF16 = 96
DXGI_FORMAT_BC7_TYPELESS = 97
DXGI_FORMAT_BC7_UNORM = 98
DXGI_FORMAT_BC7_UNORM_SRGB = 99
DXGI_FORMAT_AYUV = 100
DXGI_FORMAT_Y410 = 101
DXGI_FORMAT_Y416 = 102
DXGI_FORMAT_NV12 = 103
DXGI_FORMAT_P010 = 104
DXGI_FORMAT_P016 = 105
DXGI_FORMAT_420_OPAQUE = 106
DXGI_FORMAT_YUY2 = 107
DXGI_FORMAT_Y210 = 108
DXGI_FORMAT_Y216 = 109
DXGI_FORMAT_NV11 = 110
DXGI_FORMAT_AI44 = 111
DXGI_FORMAT_IA44 = 112
DXGI_FORMAT_P8 = 113
DXGI_FORMAT_A8P8 = 114
DXGI_FORMAT_B4G4R4A4_UNORM = 115
DXGI_FORMAT_P208 = 130
DXGI_FORMAT_V208 = 131
DXGI_FORMAT_V408 = 132
DXGI_FORMAT_SAMPLER_FEEDBACK_MIN_MIP_OPAQUE = 189
DXGI_FORMAT_SAMPLER_FEEDBACK_MIP_REGION_USED_OPAQUE = 190
DXGI_FORMAT_FORCE_UINT = -1
DXGI_FORMAT = c_int  # enum

# values for enumeration 'D3D12_TEXTURE_LAYOUT'
D3D12_TEXTURE_LAYOUT_UNKNOWN = 0
D3D12_TEXTURE_LAYOUT_ROW_MAJOR = 1
D3D12_TEXTURE_LAYOUT_64KB_UNDEFINED_SWIZZLE = 2
D3D12_TEXTURE_LAYOUT_64KB_STANDARD_SWIZZLE = 3
D3D12_TEXTURE_LAYOUT = c_int  # enum

# values for enumeration 'D3D12_RLDO_FLAGS'
D3D12_RLDO_NONE = 0
D3D12_RLDO_SUMMARY = 1
D3D12_RLDO_DETAIL = 2
D3D12_RLDO_IGNORE_INTERNAL = 4
D3D12_RLDO_FLAGS = c_int  # enum

# values for enumeration 'D3D12_HEAP_FLAGS'
D3D12_HEAP_FLAG_NONE = 0
D3D12_HEAP_FLAG_SHARED = 1
D3D12_HEAP_FLAG_DENY_BUFFERS = 4
D3D12_HEAP_FLAG_ALLOW_DISPLAY = 8
D3D12_HEAP_FLAG_SHARED_CROSS_ADAPTER = 32
D3D12_HEAP_FLAG_DENY_RT_DS_TEXTURES = 64
D3D12_HEAP_FLAG_DENY_NON_RT_DS_TEXTURES = 128
D3D12_HEAP_FLAG_HARDWARE_PROTECTED = 256
D3D12_HEAP_FLAG_ALLOW_WRITE_WATCH = 512
D3D12_HEAP_FLAG_ALLOW_SHADER_ATOMICS = 1024
D3D12_HEAP_FLAG_CREATE_NOT_RESIDENT = 2048
D3D12_HEAP_FLAG_CREATE_NOT_ZEROED = 4096
D3D12_HEAP_FLAG_ALLOW_ALL_BUFFERS_AND_TEXTURES = 0
D3D12_HEAP_FLAG_ALLOW_ONLY_BUFFERS = 192
D3D12_HEAP_FLAG_ALLOW_ONLY_NON_RT_DS_TEXTURES = 68
D3D12_HEAP_FLAG_ALLOW_ONLY_RT_DS_TEXTURES = 132
D3D12_HEAP_FLAGS = c_int  # enum

# values for enumeration 'D3D12_MESSAGE_CALLBACK_FLAGS'
D3D12_MESSAGE_CALLBACK_FLAG_NONE = 0
D3D12_MESSAGE_CALLBACK_IGNORE_FILTERS = 1
D3D12_MESSAGE_CALLBACK_FLAGS = c_int  # enum

# values for enumeration 'D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE'
D3D12_DEBUG_COMMAND_LIST_PARAMETER_GPU_BASED_VALIDATION_SETTINGS = 0
D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE = c_int  # enum



class D3D12_MESSAGE(Structure):
    pass


D3D12_MESSAGE._fields_ = [
    ('Category', D3D12_MESSAGE_CATEGORY),
    ('Severity', D3D12_MESSAGE_SEVERITY),
    ('ID', D3D12_MESSAGE_ID),
    ('pDescription', STRING),
    ('DescriptionByteLength', ULONG_PTR),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_MESSAGE is skipped.


class ID3D12Debug(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{344488B7-6846-474B-B989-F027448245E0}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def EnableDebugLayer(self) -> hints.Hresult: ...


class ID3D12Debug3(ID3D12Debug):
    _case_insensitive_ = True
    _iid_ = GUID('{5CF4E58F-F671-4FF1-A542-3686E3D153D1}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetEnableGPUBasedValidation(self, Enable: hints.Incomplete) -> hints.Hresult: ...
        def SetEnableSynchronizedCommandQueueValidation(self, Enable: hints.Incomplete) -> hints.Hresult: ...
        def SetGPUBasedValidationFlags(self, Flags: hints.Incomplete) -> hints.Hresult: ...


class ID3D12Debug4(ID3D12Debug3):
    _case_insensitive_ = True
    _iid_ = GUID('{014B816E-9EC5-4A2F-A845-FFBE441CE13A}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def DisableDebugLayer(self) -> hints.Hresult: ...


ID3D12Debug._methods_ = [
    COMMETHOD([], None, 'EnableDebugLayer'),
]

################################################################
# code template for ID3D12Debug implementation
# class ID3D12Debug_Impl(object):
#     def EnableDebugLayer(self):
#         '-no docstring-'
#         #return 
#

ID3D12Debug3._methods_ = [
    COMMETHOD(
        [],
        None,
        'SetEnableGPUBasedValidation',
        ([], c_int, 'Enable')
    ),
    COMMETHOD(
        [],
        None,
        'SetEnableSynchronizedCommandQueueValidation',
        ([], c_int, 'Enable')
    ),
    COMMETHOD(
        [],
        None,
        'SetGPUBasedValidationFlags',
        ([], D3D12_GPU_BASED_VALIDATION_FLAGS, 'Flags')
    ),
]

################################################################
# code template for ID3D12Debug3 implementation
# class ID3D12Debug3_Impl(object):
#     def SetEnableGPUBasedValidation(self, Enable):
#         '-no docstring-'
#         #return 
#
#     def SetEnableSynchronizedCommandQueueValidation(self, Enable):
#         '-no docstring-'
#         #return 
#
#     def SetGPUBasedValidationFlags(self, Flags):
#         '-no docstring-'
#         #return 
#

ID3D12Debug4._methods_ = [
    COMMETHOD([], None, 'DisableDebugLayer'),
]

################################################################
# code template for ID3D12Debug4 implementation
# class ID3D12Debug4_Impl(object):
#     def DisableDebugLayer(self):
#         '-no docstring-'
#         #return 
#


class ID3D12Object(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{C4FEC28F-7966-4E95-9F94-F431CB56C3B8}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def GetPrivateData(self, guid: hints.Incomplete, pDataSize: hints.Incomplete, pData: hints.Incomplete) -> hints.Hresult: ...
        def SetPrivateData(self, guid: hints.Incomplete, DataSize: hints.Incomplete, pData: hints.Incomplete) -> hints.Hresult: ...
        def SetPrivateDataInterface(self, guid: hints.Incomplete, pData: hints.Incomplete) -> hints.Hresult: ...
        def SetName(self, Name: hints.Incomplete) -> hints.Hresult: ...


ID3D12Object._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'GetPrivateData',
        (
            [],
            POINTER(OLE.GUID),
            'guid',
        ),
        ([], POINTER(c_uint), 'pDataSize'),
        ([], c_void_p, 'pData')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetPrivateData',
        (
            [],
            POINTER(OLE.GUID),
            'guid',
        ),
        ([], c_uint, 'DataSize'),
        ([], c_void_p, 'pData')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetPrivateDataInterface',
        (
            [],
            POINTER(OLE.GUID),
            'guid',
        ),
        ([], POINTER(IUnknown), 'pData')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetName',
        ([], WSTRING, 'Name')
    ),
]

################################################################
# code template for ID3D12Object implementation
# class ID3D12Object_Impl(object):
#     def GetPrivateData(self, guid, pDataSize, pData):
#         '-no docstring-'
#         #return 
#
#     def SetPrivateData(self, guid, DataSize, pData):
#         '-no docstring-'
#         #return 
#
#     def SetPrivateDataInterface(self, guid, pData):
#         '-no docstring-'
#         #return 
#
#     def SetName(self, Name):
#         '-no docstring-'
#         #return 
#


class ID3D12DebugCommandList(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{09E0BF36-54AC-484F-8847-4BAEEAB6053F}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def AssertResourceState(self, pResource: hints.Incomplete, Subresource: hints.Incomplete, State: hints.Incomplete) -> hints.Hresult: ...
        def SetFeatureMask(self, Mask: hints.Incomplete) -> hints.Hresult: ...
        def GetFeatureMask(self) -> hints.Hresult: ...


class ID3D12DeviceChild(ID3D12Object):
    _case_insensitive_ = True
    _iid_ = GUID('{905DB94B-A00C-4140-9DF5-2B64CA9EA357}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def GetDevice(self, riid: hints.Incomplete) -> hints.Incomplete: ...


class ID3D12Pageable(ID3D12DeviceChild):
    _case_insensitive_ = True
    _iid_ = GUID('{63EE58FB-1268-4835-86DA-F008CE62F0D6}')
    _idlflags_ = []


class ID3D12Resource(ID3D12Pageable):
    _case_insensitive_ = True
    _iid_ = GUID('{696442BE-A72E-4059-BC79-5B5C98040FAD}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def Map(self, Subresource: hints.Incomplete, pReadRange: hints.Incomplete, ppData: hints.Incomplete) -> hints.Hresult: ...
        def Unmap(self, Subresource: hints.Incomplete, pWrittenRange: hints.Incomplete) -> hints.Hresult: ...
        def GetDesc(self) -> hints.Hresult: ...
        def GetGPUVirtualAddress(self) -> hints.Hresult: ...
        def WriteToSubresource(self, DstSubresource: hints.Incomplete, pDstBox: hints.Incomplete, pSrcData: hints.Incomplete, SrcRowPitch: hints.Incomplete, SrcDepthPitch: hints.Incomplete) -> hints.Hresult: ...
        def ReadFromSubresource(self, pDstData: hints.Incomplete, DstRowPitch: hints.Incomplete, DstDepthPitch: hints.Incomplete, SrcSubresource: hints.Incomplete, pSrcBox: hints.Incomplete) -> hints.Hresult: ...
        def GetHeapProperties(self, pHeapProperties: hints.Incomplete, pHeapFlags: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugCommandList._methods_ = [
    COMMETHOD(
        [],
        c_int,
        'AssertResourceState',
        ([], POINTER(ID3D12Resource), 'pResource'),
        ([], c_uint, 'Subresource'),
        ([], c_uint, 'State')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetFeatureMask',
        ([], D3D12_DEBUG_FEATURE, 'Mask')
    ),
    COMMETHOD([], D3D12_DEBUG_FEATURE, 'GetFeatureMask'),
]

################################################################
# code template for ID3D12DebugCommandList implementation
# class ID3D12DebugCommandList_Impl(object):
#     def AssertResourceState(self, pResource, Subresource, State):
#         '-no docstring-'
#         #return 
#
#     def SetFeatureMask(self, Mask):
#         '-no docstring-'
#         #return 
#
#     def GetFeatureMask(self):
#         '-no docstring-'
#         #return 
#


class ID3D12DebugCommandQueue(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{09E0BF36-54AC-484F-8847-4BAEEAB6053A}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def AssertResourceState(self, pResource: hints.Incomplete, Subresource: hints.Incomplete, State: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugCommandQueue._methods_ = [
    COMMETHOD(
        [],
        c_int,
        'AssertResourceState',
        ([], POINTER(ID3D12Resource), 'pResource'),
        ([], c_uint, 'Subresource'),
        ([], c_uint, 'State')
    ),
]

################################################################
# code template for ID3D12DebugCommandQueue implementation
# class ID3D12DebugCommandQueue_Impl(object):
#     def AssertResourceState(self, pResource, Subresource, State):
#         '-no docstring-'
#         #return 
#

ID3D12DeviceChild._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'GetDevice',
        (
            ['in'],
            POINTER(OLE.GUID),
            'riid',
        ),
        (['out'], POINTER(c_void_p), 'ppvDevice')
    ),
]

################################################################
# code template for ID3D12DeviceChild implementation
# class ID3D12DeviceChild_Impl(object):
#     def GetDevice(self, riid):
#         '-no docstring-'
#         #return ppvDevice
#

ID3D12Pageable._methods_ = [
]

################################################################
# code template for ID3D12Pageable implementation
# class ID3D12Pageable_Impl(object):


class ID3D12SharingContract(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{0ADF7D52-929C-4E61-ADDB-FFED30DE66EF}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def Present(self, pResource: hints.Incomplete, Subresource: hints.Incomplete, window: hints.Incomplete) -> hints.Hresult: ...
        def SharedFenceSignal(self, pFence: hints.Incomplete, FenceValue: hints.Incomplete) -> hints.Hresult: ...
        def BeginCapturableWork(self, guid: hints.Incomplete) -> hints.Hresult: ...
        def EndCapturableWork(self, guid: hints.Incomplete) -> hints.Hresult: ...


class ID3D12Fence(ID3D12Pageable):
    _case_insensitive_ = True
    _iid_ = GUID('{0A753DCF-C4D8-4B91-ADF6-BE5A60D95A76}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def GetCompletedValue(self) -> hints.Hresult: ...
        def SetEventOnCompletion(self, Value: hints.Incomplete, hEvent: hints.Incomplete) -> hints.Hresult: ...
        def Signal(self, Value: hints.Incomplete) -> hints.Hresult: ...


ID3D12SharingContract._methods_ = [
    COMMETHOD(
        [],
        None,
        'Present',
        ([], POINTER(ID3D12Resource), 'pResource'),
        ([], c_uint, 'Subresource'),
        ([], wireHWND, 'window')
    ),
    COMMETHOD(
        [],
        None,
        'SharedFenceSignal',
        ([], POINTER(ID3D12Fence), 'pFence'),
        ([], c_ulonglong, 'FenceValue')
    ),
    COMMETHOD(
        [],
        None,
        'BeginCapturableWork',
        (
            [],
            POINTER(OLE.GUID),
            'guid',
        )
    ),
    COMMETHOD(
        [],
        None,
        'EndCapturableWork',
        (
            [],
            POINTER(OLE.GUID),
            'guid',
        )
    ),
]

################################################################
# code template for ID3D12SharingContract implementation
# class ID3D12SharingContract_Impl(object):
#     def Present(self, pResource, Subresource, window):
#         '-no docstring-'
#         #return 
#
#     def SharedFenceSignal(self, pFence, FenceValue):
#         '-no docstring-'
#         #return 
#
#     def BeginCapturableWork(self, guid):
#         '-no docstring-'
#         #return 
#
#     def EndCapturableWork(self, guid):
#         '-no docstring-'
#         #return 
#


class DXGI_SAMPLE_DESC(Structure):
    pass


DXGI_SAMPLE_DESC._fields_ = [
    ('Count', c_uint),
    ('Quality', c_uint),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for DXGI_SAMPLE_DESC is skipped.


class __MIDL_IWinTypes_0009(Union):
    pass


__MIDL_IWinTypes_0009._fields_ = [
    ('hInproc', c_int),
    ('hRemote', c_int),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for __MIDL_IWinTypes_0009 is skipped.


class ID3D12Debug5(ID3D12Debug4):
    _case_insensitive_ = True
    _iid_ = GUID('{548D6B12-09FA-40E0-9069-5DCD589A52C9}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetEnableAutoName(self, Enable: hints.Incomplete) -> hints.Hresult: ...


ID3D12Debug5._methods_ = [
    COMMETHOD(
        [],
        None,
        'SetEnableAutoName',
        ([], c_int, 'Enable')
    ),
]

################################################################
# code template for ID3D12Debug5 implementation
# class ID3D12Debug5_Impl(object):
#     def SetEnableAutoName(self, Enable):
#         '-no docstring-'
#         #return 
#


class D3D12_HEAP_PROPERTIES(Structure):
    pass


D3D12_HEAP_PROPERTIES._fields_ = [
    ('Type', D3D12_HEAP_TYPE),
    ('CPUPageProperty', D3D12_CPU_PAGE_PROPERTY),
    ('MemoryPoolPreference', D3D12_MEMORY_POOL),
    ('CreationNodeMask', c_uint),
    ('VisibleNodeMask', c_uint),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_HEAP_PROPERTIES is skipped.


class D3D12_RESOURCE_DESC(Structure):
    pass


D3D12_RESOURCE_DESC._fields_ = [
    ('Dimension', D3D12_RESOURCE_DIMENSION),
    ('Alignment', c_ulonglong),
    ('Width', c_ulonglong),
    ('Height', c_uint),
    ('DepthOrArraySize', c_ushort),
    ('MipLevels', c_ushort),
    ('Format', DXGI_FORMAT),
    ('SampleDesc', DXGI_SAMPLE_DESC),
    ('Layout', D3D12_TEXTURE_LAYOUT),
    ('Flags', D3D12_RESOURCE_FLAGS),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_RESOURCE_DESC is skipped.


class ID3D12DebugDevice(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{3FEBD6DD-4973-4787-8194-E45F9E28923E}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetFeatureMask(self, Mask: hints.Incomplete) -> hints.Hresult: ...
        def GetFeatureMask(self) -> hints.Hresult: ...
        def ReportLiveDeviceObjects(self, Flags: hints.Incomplete) -> hints.Hresult: ...


class ID3D12DebugDevice2(ID3D12DebugDevice):
    _case_insensitive_ = True
    _iid_ = GUID('{60ECCBC1-378D-4DF1-894C-F8AC5CE4D7DD}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...
        def GetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugDevice._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'SetFeatureMask',
        ([], D3D12_DEBUG_FEATURE, 'Mask')
    ),
    COMMETHOD([], D3D12_DEBUG_FEATURE, 'GetFeatureMask'),
    COMMETHOD(
        [],
        HRESULT,
        'ReportLiveDeviceObjects',
        ([], D3D12_RLDO_FLAGS, 'Flags')
    ),
]

################################################################
# code template for ID3D12DebugDevice implementation
# class ID3D12DebugDevice_Impl(object):
#     def SetFeatureMask(self, Mask):
#         '-no docstring-'
#         #return 
#
#     def GetFeatureMask(self):
#         '-no docstring-'
#         #return 
#
#     def ReportLiveDeviceObjects(self, Flags):
#         '-no docstring-'
#         #return 
#

ID3D12DebugDevice2._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'SetDebugParameter',
        ([], D3D12_DEBUG_DEVICE_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetDebugParameter',
        ([], D3D12_DEBUG_DEVICE_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
]

################################################################
# code template for ID3D12DebugDevice2 implementation
# class ID3D12DebugDevice2_Impl(object):
#     def SetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#
#     def GetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#


class ID3D12DebugDevice1(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{A9B71770-D099-4A65-A698-3DEE10020F88}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...
        def GetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...
        def ReportLiveDeviceObjects(self, Flags: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugDevice1._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'SetDebugParameter',
        ([], D3D12_DEBUG_DEVICE_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetDebugParameter',
        ([], D3D12_DEBUG_DEVICE_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'ReportLiveDeviceObjects',
        ([], D3D12_RLDO_FLAGS, 'Flags')
    ),
]

################################################################
# code template for ID3D12DebugDevice1 implementation
# class ID3D12DebugDevice1_Impl(object):
#     def SetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#
#     def GetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#
#     def ReportLiveDeviceObjects(self, Flags):
#         '-no docstring-'
#         #return 
#


class ID3D12Debug2(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{93A665C4-A3B2-4E5D-B692-A26AE14E3374}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetGPUBasedValidationFlags(self, Flags: hints.Incomplete) -> hints.Hresult: ...


ID3D12Debug2._methods_ = [
    COMMETHOD(
        [],
        None,
        'SetGPUBasedValidationFlags',
        ([], D3D12_GPU_BASED_VALIDATION_FLAGS, 'Flags')
    ),
]

################################################################
# code template for ID3D12Debug2 implementation
# class ID3D12Debug2_Impl(object):
#     def SetGPUBasedValidationFlags(self, Flags):
#         '-no docstring-'
#         #return 
#


class D3D12_INFO_QUEUE_FILTER(Structure):
    pass


class D3D12_INFO_QUEUE_FILTER_DESC(Structure):
    pass


D3D12_INFO_QUEUE_FILTER_DESC._fields_ = [
    ('NumCategories', c_uint),
    ('pCategoryList', POINTER(D3D12_MESSAGE_CATEGORY)),
    ('NumSeverities', c_uint),
    ('pSeverityList', POINTER(D3D12_MESSAGE_SEVERITY)),
    ('NumIDs', c_uint),
    ('pIDList', POINTER(D3D12_MESSAGE_ID)),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_INFO_QUEUE_FILTER_DESC is skipped.

D3D12_INFO_QUEUE_FILTER._fields_ = [
    ('AllowList', D3D12_INFO_QUEUE_FILTER_DESC),
    ('DenyList', D3D12_INFO_QUEUE_FILTER_DESC),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_INFO_QUEUE_FILTER is skipped.


class D3D12_RANGE(Structure):
    pass


class D3D12_BOX(Structure):
    pass


ID3D12Resource._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'Map',
        ([], c_uint, 'Subresource'),
        ([], POINTER(D3D12_RANGE), 'pReadRange'),
        ([], POINTER(c_void_p), 'ppData')
    ),
    COMMETHOD(
        [],
        None,
        'Unmap',
        ([], c_uint, 'Subresource'),
        ([], POINTER(D3D12_RANGE), 'pWrittenRange')
    ),
    COMMETHOD([], D3D12_RESOURCE_DESC, 'GetDesc'),
    COMMETHOD([], c_ulonglong, 'GetGPUVirtualAddress'),
    COMMETHOD(
        [],
        HRESULT,
        'WriteToSubresource',
        ([], c_uint, 'DstSubresource'),
        ([], POINTER(D3D12_BOX), 'pDstBox'),
        ([], c_void_p, 'pSrcData'),
        ([], c_uint, 'SrcRowPitch'),
        ([], c_uint, 'SrcDepthPitch')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'ReadFromSubresource',
        ([], c_void_p, 'pDstData'),
        ([], c_uint, 'DstRowPitch'),
        ([], c_uint, 'DstDepthPitch'),
        ([], c_uint, 'SrcSubresource'),
        ([], POINTER(D3D12_BOX), 'pSrcBox')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetHeapProperties',
        ([], POINTER(D3D12_HEAP_PROPERTIES), 'pHeapProperties'),
        ([], POINTER(D3D12_HEAP_FLAGS), 'pHeapFlags')
    ),
]

################################################################
# code template for ID3D12Resource implementation
# class ID3D12Resource_Impl(object):
#     def Map(self, Subresource, pReadRange, ppData):
#         '-no docstring-'
#         #return 
#
#     def Unmap(self, Subresource, pWrittenRange):
#         '-no docstring-'
#         #return 
#
#     def GetDesc(self):
#         '-no docstring-'
#         #return 
#
#     def GetGPUVirtualAddress(self):
#         '-no docstring-'
#         #return 
#
#     def WriteToSubresource(self, DstSubresource, pDstBox, pSrcData, SrcRowPitch, SrcDepthPitch):
#         '-no docstring-'
#         #return 
#
#     def ReadFromSubresource(self, pDstData, DstRowPitch, DstDepthPitch, SrcSubresource, pSrcBox):
#         '-no docstring-'
#         #return 
#
#     def GetHeapProperties(self, pHeapProperties, pHeapFlags):
#         '-no docstring-'
#         #return 
#


class _RemotableHandle(Structure):
    pass


_RemotableHandle._fields_ = [
    ('fContext', c_int),
    ('u', __MIDL_IWinTypes_0009),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for _RemotableHandle is skipped.


class Library(object):
    name = 'D3D12Lib'
    _reg_typelib_ = ('{4173F496-2048-0000-8102-5D495D6A058B}', 1, 0)


class ID3D12InfoQueue(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{0742A90B-C387-483F-B946-30A7E4E61458}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetMessageCountLimit(self, MessageCountLimit: hints.Incomplete) -> hints.Hresult: ...
        def ClearStoredMessages(self) -> hints.Hresult: ...
        def GetMessage(self, MessageIndex: hints.Incomplete, pMessage: hints.Incomplete, pMessageByteLength: hints.Incomplete) -> hints.Hresult: ...
        def GetNumMessagesAllowedByStorageFilter(self) -> hints.Hresult: ...
        def GetNumMessagesDeniedByStorageFilter(self) -> hints.Hresult: ...
        def GetNumStoredMessages(self) -> hints.Hresult: ...
        def GetNumStoredMessagesAllowedByRetrievalFilter(self) -> hints.Hresult: ...
        def GetNumMessagesDiscardedByMessageCountLimit(self) -> hints.Hresult: ...
        def GetMessageCountLimit(self) -> hints.Hresult: ...
        def AddStorageFilterEntries(self, pFilter: hints.Incomplete) -> hints.Hresult: ...
        def GetStorageFilter(self, pFilter: hints.Incomplete, pFilterByteLength: hints.Incomplete) -> hints.Hresult: ...
        def ClearStorageFilter(self) -> hints.Hresult: ...
        def PushEmptyStorageFilter(self) -> hints.Hresult: ...
        def PushCopyOfStorageFilter(self) -> hints.Hresult: ...
        def PushStorageFilter(self, pFilter: hints.Incomplete) -> hints.Hresult: ...
        def PopStorageFilter(self) -> hints.Hresult: ...
        def GetStorageFilterStackSize(self) -> hints.Hresult: ...
        def AddRetrievalFilterEntries(self, pFilter: hints.Incomplete) -> hints.Hresult: ...
        def GetRetrievalFilter(self, pFilter: hints.Incomplete, pFilterByteLength: hints.Incomplete) -> hints.Hresult: ...
        def ClearRetrievalFilter(self) -> hints.Hresult: ...
        def PushEmptyRetrievalFilter(self) -> hints.Hresult: ...
        def PushCopyOfRetrievalFilter(self) -> hints.Hresult: ...
        def PushRetrievalFilter(self, pFilter: hints.Incomplete) -> hints.Hresult: ...
        def PopRetrievalFilter(self) -> hints.Hresult: ...
        def GetRetrievalFilterStackSize(self) -> hints.Hresult: ...
        def AddMessage(self, Category: hints.Incomplete, Severity: hints.Incomplete, ID: hints.Incomplete, pDescription: hints.Incomplete) -> hints.Hresult: ...
        def AddApplicationMessage(self, Severity: hints.Incomplete, pDescription: hints.Incomplete) -> hints.Hresult: ...
        def SetBreakOnCategory(self, Category: hints.Incomplete, bEnable: hints.Incomplete) -> hints.Hresult: ...
        def SetBreakOnSeverity(self, Severity: hints.Incomplete, bEnable: hints.Incomplete) -> hints.Hresult: ...
        def SetBreakOnID(self, ID: hints.Incomplete, bEnable: hints.Incomplete) -> hints.Hresult: ...
        def GetBreakOnCategory(self, Category: hints.Incomplete) -> hints.Hresult: ...
        def GetBreakOnSeverity(self, Severity: hints.Incomplete) -> hints.Hresult: ...
        def GetBreakOnID(self, ID: hints.Incomplete) -> hints.Hresult: ...
        def SetMuteDebugOutput(self, bMute: hints.Incomplete) -> hints.Hresult: ...
        def GetMuteDebugOutput(self) -> hints.Hresult: ...


class ID3D12InfoQueue1(ID3D12InfoQueue):
    _case_insensitive_ = True
    _iid_ = GUID('{2852DD88-B484-4C0C-B6B1-67168500E600}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def __MIDL____MIDL_itf_d3d12sdklayers_0000_00160000(self, Category: hints.Incomplete, Severity: hints.Incomplete, ID: hints.Incomplete, pDescription: hints.Incomplete, pContext: hints.Incomplete) -> hints.Hresult: ...
        def RegisterMessageCallback(self, CallbackFunc: hints.Incomplete, CallbackFilterFlags: hints.Incomplete, pContext: hints.Incomplete, pCallbackCookie: hints.Incomplete) -> hints.Hresult: ...
        def UnregisterMessageCallback(self, CallbackCookie: hints.Incomplete) -> hints.Hresult: ...


ID3D12InfoQueue._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'SetMessageCountLimit',
        ([], c_ulonglong, 'MessageCountLimit')
    ),
    COMMETHOD([], None, 'ClearStoredMessages'),
    COMMETHOD(
        [],
        HRESULT,
        'GetMessage',
        ([], c_ulonglong, 'MessageIndex'),
        ([], POINTER(D3D12_MESSAGE), 'pMessage'),
        ([], POINTER(ULONG_PTR), 'pMessageByteLength')
    ),
    COMMETHOD([], c_ulonglong, 'GetNumMessagesAllowedByStorageFilter'),
    COMMETHOD([], c_ulonglong, 'GetNumMessagesDeniedByStorageFilter'),
    COMMETHOD([], c_ulonglong, 'GetNumStoredMessages'),
    COMMETHOD([], c_ulonglong, 'GetNumStoredMessagesAllowedByRetrievalFilter'),
    COMMETHOD([], c_ulonglong, 'GetNumMessagesDiscardedByMessageCountLimit'),
    COMMETHOD([], c_ulonglong, 'GetMessageCountLimit'),
    COMMETHOD(
        [],
        HRESULT,
        'AddStorageFilterEntries',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetStorageFilter',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter'),
        ([], POINTER(ULONG_PTR), 'pFilterByteLength')
    ),
    COMMETHOD([], None, 'ClearStorageFilter'),
    COMMETHOD([], HRESULT, 'PushEmptyStorageFilter'),
    COMMETHOD([], HRESULT, 'PushCopyOfStorageFilter'),
    COMMETHOD(
        [],
        HRESULT,
        'PushStorageFilter',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter')
    ),
    COMMETHOD([], None, 'PopStorageFilter'),
    COMMETHOD([], c_uint, 'GetStorageFilterStackSize'),
    COMMETHOD(
        [],
        HRESULT,
        'AddRetrievalFilterEntries',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetRetrievalFilter',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter'),
        ([], POINTER(ULONG_PTR), 'pFilterByteLength')
    ),
    COMMETHOD([], None, 'ClearRetrievalFilter'),
    COMMETHOD([], HRESULT, 'PushEmptyRetrievalFilter'),
    COMMETHOD([], HRESULT, 'PushCopyOfRetrievalFilter'),
    COMMETHOD(
        [],
        HRESULT,
        'PushRetrievalFilter',
        ([], POINTER(D3D12_INFO_QUEUE_FILTER), 'pFilter')
    ),
    COMMETHOD([], None, 'PopRetrievalFilter'),
    COMMETHOD([], c_uint, 'GetRetrievalFilterStackSize'),
    COMMETHOD(
        [],
        HRESULT,
        'AddMessage',
        ([], D3D12_MESSAGE_CATEGORY, 'Category'),
        ([], D3D12_MESSAGE_SEVERITY, 'Severity'),
        ([], D3D12_MESSAGE_ID, 'ID'),
        ([], STRING, 'pDescription')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'AddApplicationMessage',
        ([], D3D12_MESSAGE_SEVERITY, 'Severity'),
        ([], STRING, 'pDescription')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetBreakOnCategory',
        ([], D3D12_MESSAGE_CATEGORY, 'Category'),
        ([], c_int, 'bEnable')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetBreakOnSeverity',
        ([], D3D12_MESSAGE_SEVERITY, 'Severity'),
        ([], c_int, 'bEnable')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetBreakOnID',
        ([], D3D12_MESSAGE_ID, 'ID'),
        ([], c_int, 'bEnable')
    ),
    COMMETHOD(
        [],
        c_int,
        'GetBreakOnCategory',
        ([], D3D12_MESSAGE_CATEGORY, 'Category')
    ),
    COMMETHOD(
        [],
        c_int,
        'GetBreakOnSeverity',
        ([], D3D12_MESSAGE_SEVERITY, 'Severity')
    ),
    COMMETHOD(
        [],
        c_int,
        'GetBreakOnID',
        ([], D3D12_MESSAGE_ID, 'ID')
    ),
    COMMETHOD(
        [],
        None,
        'SetMuteDebugOutput',
        ([], c_int, 'bMute')
    ),
    COMMETHOD([], c_int, 'GetMuteDebugOutput'),
]

################################################################
# code template for ID3D12InfoQueue implementation
# class ID3D12InfoQueue_Impl(object):
#     def SetMessageCountLimit(self, MessageCountLimit):
#         '-no docstring-'
#         #return 
#
#     def ClearStoredMessages(self):
#         '-no docstring-'
#         #return 
#
#     def GetMessage(self, MessageIndex, pMessage, pMessageByteLength):
#         '-no docstring-'
#         #return 
#
#     def GetNumMessagesAllowedByStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def GetNumMessagesDeniedByStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def GetNumStoredMessages(self):
#         '-no docstring-'
#         #return 
#
#     def GetNumStoredMessagesAllowedByRetrievalFilter(self):
#         '-no docstring-'
#         #return 
#
#     def GetNumMessagesDiscardedByMessageCountLimit(self):
#         '-no docstring-'
#         #return 
#
#     def GetMessageCountLimit(self):
#         '-no docstring-'
#         #return 
#
#     def AddStorageFilterEntries(self, pFilter):
#         '-no docstring-'
#         #return 
#
#     def GetStorageFilter(self, pFilter, pFilterByteLength):
#         '-no docstring-'
#         #return 
#
#     def ClearStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushEmptyStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushCopyOfStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushStorageFilter(self, pFilter):
#         '-no docstring-'
#         #return 
#
#     def PopStorageFilter(self):
#         '-no docstring-'
#         #return 
#
#     def GetStorageFilterStackSize(self):
#         '-no docstring-'
#         #return 
#
#     def AddRetrievalFilterEntries(self, pFilter):
#         '-no docstring-'
#         #return 
#
#     def GetRetrievalFilter(self, pFilter, pFilterByteLength):
#         '-no docstring-'
#         #return 
#
#     def ClearRetrievalFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushEmptyRetrievalFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushCopyOfRetrievalFilter(self):
#         '-no docstring-'
#         #return 
#
#     def PushRetrievalFilter(self, pFilter):
#         '-no docstring-'
#         #return 
#
#     def PopRetrievalFilter(self):
#         '-no docstring-'
#         #return 
#
#     def GetRetrievalFilterStackSize(self):
#         '-no docstring-'
#         #return 
#
#     def AddMessage(self, Category, Severity, ID, pDescription):
#         '-no docstring-'
#         #return 
#
#     def AddApplicationMessage(self, Severity, pDescription):
#         '-no docstring-'
#         #return 
#
#     def SetBreakOnCategory(self, Category, bEnable):
#         '-no docstring-'
#         #return 
#
#     def SetBreakOnSeverity(self, Severity, bEnable):
#         '-no docstring-'
#         #return 
#
#     def SetBreakOnID(self, ID, bEnable):
#         '-no docstring-'
#         #return 
#
#     def GetBreakOnCategory(self, Category):
#         '-no docstring-'
#         #return 
#
#     def GetBreakOnSeverity(self, Severity):
#         '-no docstring-'
#         #return 
#
#     def GetBreakOnID(self, ID):
#         '-no docstring-'
#         #return 
#
#     def SetMuteDebugOutput(self, bMute):
#         '-no docstring-'
#         #return 
#
#     def GetMuteDebugOutput(self):
#         '-no docstring-'
#         #return 
#

ID3D12InfoQueue1._methods_ = [
    COMMETHOD(
        [],
        None,
        '__MIDL____MIDL_itf_d3d12sdklayers_0000_00160000',
        ([], D3D12_MESSAGE_CATEGORY, 'Category'),
        ([], D3D12_MESSAGE_SEVERITY, 'Severity'),
        ([], D3D12_MESSAGE_ID, 'ID'),
        ([], STRING, 'pDescription'),
        ([], c_void_p, 'pContext')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'RegisterMessageCallback',
        ([], POINTER(ID3D12InfoQueue1), 'CallbackFunc'),
        ([], D3D12_MESSAGE_CALLBACK_FLAGS, 'CallbackFilterFlags'),
        ([], c_void_p, 'pContext'),
        ([], POINTER(c_ulong), 'pCallbackCookie')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'UnregisterMessageCallback',
        ([], c_ulong, 'CallbackCookie')
    ),
]

################################################################
# code template for ID3D12InfoQueue1 implementation
# class ID3D12InfoQueue1_Impl(object):
#     def __MIDL____MIDL_itf_d3d12sdklayers_0000_00160000(self, Category, Severity, ID, pDescription, pContext):
#         '-no docstring-'
#         #return 
#
#     def RegisterMessageCallback(self, CallbackFunc, CallbackFilterFlags, pContext, pCallbackCookie):
#         '-no docstring-'
#         #return 
#
#     def UnregisterMessageCallback(self, CallbackCookie):
#         '-no docstring-'
#         #return 
#

D3D12_RANGE._fields_ = [
    ('Begin', ULONG_PTR),
    ('End', ULONG_PTR),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_RANGE is skipped.


class ID3D12DebugCommandList2(ID3D12DebugCommandList):
    _case_insensitive_ = True
    _iid_ = GUID('{AEB575CF-4E06-48BE-BA3B-C450FC96652E}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...
        def GetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugCommandList2._methods_ = [
    COMMETHOD(
        [],
        HRESULT,
        'SetDebugParameter',
        ([], D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetDebugParameter',
        ([], D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
]

################################################################
# code template for ID3D12DebugCommandList2 implementation
# class ID3D12DebugCommandList2_Impl(object):
#     def SetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#
#     def GetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#


class ID3D12Debug1(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{AFFAA4CA-63FE-4D8E-B8AD-159000AF4304}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def EnableDebugLayer(self) -> hints.Hresult: ...
        def SetEnableGPUBasedValidation(self, Enable: hints.Incomplete) -> hints.Hresult: ...
        def SetEnableSynchronizedCommandQueueValidation(self, Enable: hints.Incomplete) -> hints.Hresult: ...


ID3D12Debug1._methods_ = [
    COMMETHOD([], None, 'EnableDebugLayer'),
    COMMETHOD(
        [],
        None,
        'SetEnableGPUBasedValidation',
        ([], c_int, 'Enable')
    ),
    COMMETHOD(
        [],
        None,
        'SetEnableSynchronizedCommandQueueValidation',
        ([], c_int, 'Enable')
    ),
]

################################################################
# code template for ID3D12Debug1 implementation
# class ID3D12Debug1_Impl(object):
#     def EnableDebugLayer(self):
#         '-no docstring-'
#         #return 
#
#     def SetEnableGPUBasedValidation(self, Enable):
#         '-no docstring-'
#         #return 
#
#     def SetEnableSynchronizedCommandQueueValidation(self, Enable):
#         '-no docstring-'
#         #return 
#

ID3D12Fence._methods_ = [
    COMMETHOD([], c_ulonglong, 'GetCompletedValue'),
    COMMETHOD(
        [],
        HRESULT,
        'SetEventOnCompletion',
        ([], c_ulonglong, 'Value'),
        ([], c_void_p, 'hEvent')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'Signal',
        ([], c_ulonglong, 'Value')
    ),
]

################################################################
# code template for ID3D12Fence implementation
# class ID3D12Fence_Impl(object):
#     def GetCompletedValue(self):
#         '-no docstring-'
#         #return 
#
#     def SetEventOnCompletion(self, Value, hEvent):
#         '-no docstring-'
#         #return 
#
#     def Signal(self, Value):
#         '-no docstring-'
#         #return 
#


class ID3D12DebugCommandList1(OLE.IUnknown):
    _case_insensitive_ = True
    _iid_ = GUID('{102CA951-311B-4B01-B11F-ECB83E061B37}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def AssertResourceState(self, pResource: hints.Incomplete, Subresource: hints.Incomplete, State: hints.Incomplete) -> hints.Hresult: ...
        def SetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...
        def GetDebugParameter(self, Type: hints.Incomplete, pData: hints.Incomplete, DataSize: hints.Incomplete) -> hints.Hresult: ...


ID3D12DebugCommandList1._methods_ = [
    COMMETHOD(
        [],
        c_int,
        'AssertResourceState',
        ([], POINTER(ID3D12Resource), 'pResource'),
        ([], c_uint, 'Subresource'),
        ([], c_uint, 'State')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'SetDebugParameter',
        ([], D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
    COMMETHOD(
        [],
        HRESULT,
        'GetDebugParameter',
        ([], D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE, 'Type'),
        ([], c_void_p, 'pData'),
        ([], c_uint, 'DataSize')
    ),
]

################################################################
# code template for ID3D12DebugCommandList1 implementation
# class ID3D12DebugCommandList1_Impl(object):
#     def AssertResourceState(self, pResource, Subresource, State):
#         '-no docstring-'
#         #return 
#
#     def SetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#
#     def GetDebugParameter(self, Type, pData, DataSize):
#         '-no docstring-'
#         #return 
#

D3D12_BOX._fields_ = [
    ('left', c_uint),
    ('top', c_uint),
    ('front', c_uint),
    ('right', c_uint),
    ('bottom', c_uint),
    ('back', c_uint),
]

# The size provided by the typelib is incorrect.
# The size and alignment check for D3D12_BOX is skipped.


class ID3D12Debug6(ID3D12Debug5):
    _case_insensitive_ = True
    _iid_ = GUID('{82A816D6-5D01-4157-97D0-4975463FD1ED}')
    _idlflags_ = []

    if TYPE_CHECKING:  # commembers
        def SetForceLegacyBarrierValidation(self, Enable: hints.Incomplete) -> hints.Hresult: ...


ID3D12Debug6._methods_ = [
    COMMETHOD(
        [],
        None,
        'SetForceLegacyBarrierValidation',
        ([], c_int, 'Enable')
    ),
]

################################################################
# code template for ID3D12Debug6 implementation
# class ID3D12Debug6_Impl(object):
#     def SetForceLegacyBarrierValidation(self, Enable):
#         '-no docstring-'
#         #return 
#

__all__ = [
    'D3D12_MESSAGE_ID_COMPUTE_ONLY_DEVICE_OPERATION_UNSUPPORTED',
    'DXGI_FORMAT_BC6H_SF16',
    'D3D12_MESSAGE_ID_SETDEPTHBOUNDS_INVALIDARGS',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_CORRUPT',
    'D3D12_MESSAGE_ID_VRS_SUM_COMBINER_REQUIRES_CAPABILITY',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_RESET',
    'D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDADDRESS',
    'D3D12_RLDO_IGNORE_INTERNAL', 'D3D12_BOX',
    'DXGI_FORMAT_D16_UNORM',
    'D3D12_MESSAGE_ID_UNMAP_INVALID_NULLRANGE',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCEREGION_INVALID_RECT',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_DEPTHBOUNDSTEST_UNSUPPORTED',
    'D3D12_MESSAGE_SEVERITY_ERROR',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_SAMPLE_COUNT',
    'D3D12_HEAP_TYPE_UPLOAD',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFORCEDSAMPLECOUNT',
    'D3D12_MESSAGE_ID_RESOLVE_QUERY_INVALID_QUERY_STATE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGOUTPUTSIGNATURE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_MULTIPLE_SWAPCHAIN_BUFFER_REFERENCES',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_DIMENSION',
    'D3D12_MESSAGE_ID_SETPRIVATEDATA_NO_ACCESS',
    'DXGI_FORMAT_B5G6R5_UNORM',
    'D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_UAVSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDMISCFLAGS',
    'D3D12_MESSAGE_ID_CREATE_VIDEODECODESTREAM',
    'D3D12_MESSAGE_ID_OVERSIZED_DISPATCH',
    'D3D12_MESSAGE_ID_RENDER_PASS_ERROR', 'ID3D12Debug3',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_RESOURCE_STATE_IMPRECISE',
    'D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_ALIGNMENT',
    'D3D12_MESSAGE_ID_DESTROYOWNEDOBJECT_OBJECTNOTOWNED',
    'DXGI_FORMAT_R16_UNORM',
    'D3D12_MESSAGE_ID_COPY_RAYTRACING_ACCELERATION_STRUCTURE_INVALID',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCBOX',
    'D3D12_MESSAGE_ID_MAP_INVALIDDATAPOINTER',
    'D3D12_MESSAGE_ID_END_EVENT',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_INVALID_RESOURCE',
    'D3D12_MESSAGE_ID_RSSETSHADINGRATE_REQUIRES_TIER_1',
    'D3D12_MESSAGE_ID_SHADERCACHECONTROL_SHADERCACHECLEAR_NOTSUPPORTED',
    'D3D12_CPU_PAGE_PROPERTY',
    'D3D12_MESSAGE_ID_RENDER_TARGET_FORMAT_MISMATCH_PIPELINE_STATE',
    'DXGI_FORMAT_B8G8R8X8_TYPELESS',
    'D3D12_MESSAGE_ID_CREATEAMPLIFICATIONSHADER_INVALIDSHADERBYTECODE',
    'DXGI_FORMAT_Y416', 'D3D12_MESSAGE_ID_EVICT_NULLOBJECTARRAY',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDCULLMODE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTSUBRESOURCE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_USE_OF_FORCED_SAMPLE_COUNT',
    'D3D12_MESSAGE_ID_LIVE_VIDEODECODER',
    'D3D12_MESSAGE_ID_UPDATETILEMAPPINGS_INVALID_PARAMETER',
    'D3D12_TEXTURE_LAYOUT_ROW_MAJOR',
    'D3D12_MESSAGE_ID_CANNOT_ADD_TRACKED_WORKLOAD',
    'D3D12_MESSAGE_ID_COPYTILEMAPPINGS_INVALID_PARAMETER',
    'ID3D12Debug5',
    'D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDRESOURCE',
    'D3D12_RLDO_FLAGS',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_UAVSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDDIMENSIONALITY',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_DSTRANGEOUTOFBOUNDS',
    'D3D12_MESSAGE_ID_SETPRIVATEDATA_INVALIDFREEDATA',
    'D3D12_MESSAGE_ID_CANNOT_CREATE_GRAPHICS_AND_VIDEO_COMMAND_RECORDER',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER6',
    'D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_UNRECOGNIZEDPROPERTIES',
    'D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_CONSTANT_BUFFER_VIEW_NOT_SET',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDARG_RETURN',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDIMENSIONS',
    'DXGI_FORMAT_R10G10B10A2_UINT', 'DXGI_FORMAT_R16G16_SNORM',
    'D3D12_MESSAGE_ID_UNUSED_CROSS_EXECUTE_SPLIT_BARRIER',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALID_SRC_RESOURCE',
    'DXGI_FORMAT_R32G32_SINT',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_INCOMPATIBLE_RESOURCE_STATE',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHFUNC',
    'D3D12_MESSAGE_ID_CREATESHAREDRESOURCE_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_DESTROY_LIBRARY', 'DXGI_FORMAT_R32_TYPELESS',
    'D3D12_MESSAGE_ID_DATA_STATIC_WHILE_SET_AT_EXECUTE_DESCRIPTOR_INVALID_DATA_CHANGE',
    'DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM',
    'D3D12_MESSAGE_ID_COMMAND_LIST_TOO_MANY_SWAPCHAIN_REFERENCES',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_UAV_REQUIRES_SAMPLER_FEEDBACK_CAPABILITY',
    'D3D12_MESSAGE_ID_COPYRESOURCE_NULLDST',
    'D3D12_MESSAGE_CATEGORY_CLEANUP',
    'D3D12_DEBUG_DEVICE_PARAMETER_GPU_BASED_VALIDATION_SETTINGS',
    'D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_ALREADYOPEN',
    'D3D12_MESSAGE_ID_CREATE_PROTECTED_RESOURCE_SESSION_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_DESTROY_LIFETIMETRACKER',
    'D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_INVALIDSUBRESOURCERANGE',
    'D3D12_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_CALLBACK_IGNORE_FILTERS',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCPLACEMENT',
    'D3D12_MESSAGE_ID_MULTIPLE_TRACKED_WORKLOADS',
    'D3D12_MESSAGE_ID_CREATERESOURCE_OUTOFMEMORY_RETURN',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLHEAP',
    'D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_MODE',
    'DXGI_FORMAT_BC2_UNORM',
    'D3D12_GPU_BASED_VALIDATION_FLAGS_DISABLE_STATE_TRACKING',
    'D3D12_MEMORY_POOL_L1',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_INVALID_CONFIGURATION',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_SUBRESOURCE_INDEX',
    'D3D12_MESSAGE_ID_HEAP_ADDRESS_RANGE_HAS_NO_RESOURCE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_UNMATCHED_END',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_ALLOCATOR_VIDEO_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_MISMATCHED_DATA_SIZE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTRIDES',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_SRCRANGEOUTOFBOUNDS',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDDSTTYPE',
    'D3D12_MESSAGE_ID_CREATEHEAP_OUTOFMEMORY_RETURN',
    'D3D12_MESSAGE_ID_COPYRESOURCE_INVALIDDSTRESOURCE',
    'D3D12_MESSAGE_ID_CREATE_LIFETIMETRACKER',
    'D3D12_MESSAGE_ID_CREATE_VIDEOMOTIONESTIMATOR',
    'D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDHEAPTYPE',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_FINDVALUE_NOTFOUND',
    'D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSSTREAM',
    'D3D12_MESSAGE_ID_WRITE_COMBINE_PERFORMANCE_WARNING',
    'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_VALUES',
    'ID3D12DebugDevice',
    'D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDHEAP',
    'DXGI_FORMAT_R16G16B16A16_FLOAT',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISSING_BIND_FLAGS',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALIDSRCRESOURCE',
    'D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_INVALIDBASEOFFSET',
    'D3D12_MESSAGE_ID_CREATESHADER_INVALIDBYTECODE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_AS_NOT_MS_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_COMMANDSIGNATURE',
    'D3D12_MESSAGE_ID_PRIMITIVE_TOPOLOGY_MISMATCH_PIPELINE_STATE',
    'DXGI_FORMAT_R8G8B8A8_UNORM',
    'D3D12_MESSAGE_ID_CREATEHEAP_INVALIDPROPERTIES',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ROOT_SIGNATURE_NOT_SET',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDALLOCATOR',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_SYSTEMVALUE',
    'D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_LOADPIPELINE_NAMENOTFOUND',
    'D3D12_MESSAGE_ID_CREATE_FENCE_INVALID_FLAGS',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_TOPOLOGY_MISMATCH',
    'D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'DXGI_FORMAT_BC5_SNORM',
    'D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_EMPTYBOX',
    'D3D12_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_INVALID_RESOURCE_PTR',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MISSING_ROOT_SIGNATURE',
    'DXGI_FORMAT_A8_UNORM', 'D3D12_MESSAGE_ID_LIVE_OBJECT_SUMMARY',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_RESOURCE_FLAGS_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDHANDLE',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLHEAPPROPERTIES',
    'D3D12_MESSAGE_ID_CANNOT_USE_COMMAND_RECORDER_WITHOUT_CURRENT_TARGET',
    'D3D12_MESSAGE_ID_COMMAND_LIST_CLOSED',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_RENDER_TARGET_DELETED',
    'D3D12_MESSAGE_SEVERITY_INFO',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_NOT_SUPPORTED_ON_DEVICE',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_UAV_RESOURCE_DIMENSION_MISMATCH',
    'D3D12_RANGE', 'D3D12_DEBUG_COMMAND_LIST_PARAMETER_TYPE',
    'D3D12_MESSAGE_ID_ENCODE_FRAME_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_VIDEO_EXTENSION_COMMAND_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TRAILING_DIGIT_IN_SEMANTIC',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_DUPLICATE_SUBOBJECT',
    'D3D12_MESSAGE_ID_CREATE_ROOTSIGNATURE',
    'D3D12_MESSAGE_ID_WINDOWS7_FENCE_OUTOFORDER_SIGNAL',
    'D3D12_MESSAGE_ID_VIDEO_CREATE_MOTION_ESTIMATOR_INVALID_ARGUMENT',
    'DXGI_FORMAT_R32G32B32A32_TYPELESS',
    'D3D12_MESSAGE_ID_COPY_ON_SAME_SUBRESOURCE',
    'D3D12_MESSAGE_ID_SHADERCACHECONTROL_DEVELOPERMODE',
    'D3D12_MESSAGE_ID_SET_PREDICATION_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDALIGNMENT',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_HEAP_INDEX_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_POSSIBLY_AT_FAULT',
    'DXGI_FORMAT_R8G8B8A8_SNORM',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_CANTHAVEONLYGAPS',
    'DXGI_FORMAT_FORCE_UINT',
    'D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDLAYOUT',
    'D3D12_MESSAGE_ID_CREATEQUERY_HEAP_INVALID_PARAMETERS',
    'DXGI_FORMAT_R32G32B32A32_SINT',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDCLEARVALUEFORMAT',
    'D3D12_MESSAGE_ID_DESTROY_QUERYHEAP',
    'D3D12_MESSAGE_ID_CANNOT_EXECUTE_EMPTY_COMMAND_LIST',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_GROUPSHAREDEXCEEDSMAXSIZE',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER4',
    'D3D12_MESSAGE_ID_NONZERO_SAMPLER_FEEDBACK_MIP_REGION_WITH_INCOMPATIBLE_FORMAT',
    'D3D12_MESSAGE_ID_CHECK_DRIVER_MATCHING_IDENTIFIER_INVALID',
    'D3D12_MESSAGE_ID_LIVE_VIDEOENCODECOMMANDLIST',
    'D3D12_CPU_PAGE_PROPERTY_NOT_AVAILABLE',
    'D3D12_MESSAGE_ID_COMMAND_RECORDER_USAGE_WITH_CREATECOMMANDLIST_COMMAND_LIST',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_HASHCOLLISION',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_SRV_RESOURCE_DIMENSION_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBDESCMISMATCH',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_OFFSET_UNALIGNED',
    'D3D12_MESSAGE_ID_DEVICE_CREATE_SHARED_HANDLE_INVALIDARG',
    'DXGI_FORMAT_BC4_SNORM', 'D3D12_HEAP_FLAG_HARDWARE_PROTECTED',
    'D3D12_MESSAGE_ID_COMMAND_LIST_OPEN',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_SPLIT_BARRIER',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_FLAGS',
    'D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDHEAP',
    'D3D12_MESSAGE_ID_CREATE_STATE_OBJECT_ERROR',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFILLMODE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCSUBRESOURCE',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLENDALPHA',
    'DXGI_FORMAT_BC1_UNORM',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_DISABLED',
    'DXGI_FORMAT_BC2_UNORM_SRGB',
    'D3D12_HEAP_FLAG_SHARED_CROSS_ADAPTER',
    'D3D12_MESSAGE_ID_VIDEO_PROCESS_SUPPORT_INVALID_INPUT',
    'DXGI_FORMAT_X32_TYPELESS_G8X24_UINT',
    'D3D12_MESSAGE_ID_INVALID_USE_OF_NON_RESIDENT_RESOURCE',
    'D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_SAMPLE_COUNT',
    'D3D12_MESSAGE_ID_LIVE_RESOURCE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_POSITION_NOT_PRESENT',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBDRIVERVERSIONMISMATCH',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_MODEL_MISMATCH',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_UNRECOGNIZEDFORMAT',
    'D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSOR',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_RESOURCE_DIMENSION',
    'D3D12_MESSAGE_ID_OPENEXISTINGHEAP_UNSUPPORTED',
    'D3D12_MESSAGE_ID_RSSETSHADING_RATE_SHADING_RATE_NOT_PERMITTED_BY_CAP',
    'D3D12_CPU_PAGE_PROPERTY_WRITE_BACK',
    'D3D12_MESSAGE_ID_CREATEAMPLIFICATIONSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATERESOURCE_STATE_IGNORED',
    'DXGI_FORMAT_G8R8_G8B8_UNORM',
    'D3D12_MESSAGE_ID_DISCARD_INVALID_SUBRESOURCE_RANGE',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_NULL_BUFFER',
    'D3D12_DEBUG_DEVICE_PARAMETER_GPU_SLOWDOWN_PERFORMANCE_FACTOR',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_INVALID_SUPPORT_FLAGS',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_CANNOT_RESET',
    'D3D12_MESSAGE_ID_CREATEDEVICE_DEBUG_LAYER_STARTUP_OPTIONS',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_FORMAT_INVALID',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_NEVERWRITTEN_ALWAYSREADS',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ELEMENT_OFFSET_UNALIGNED',
    'D3D12_MESSAGE_ID_CREATERESOURCE_CLEARVALUEDENORMFLUSH',
    'D3D12_MESSAGE_ID_NO_VIDEO_API_SUPPORT',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_NULLSEMANTIC',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDALIGNMENT',
    'D3D12_RLDO_NONE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTPLACEMENT',
    'D3D12_MESSAGE_ID_DEVICE_CLEARVIEW_INVALIDSOURCERECT',
    'DXGI_FORMAT_B5G5R5A1_UNORM',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHWRITEMASK',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_SYSTEMVALUE',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDCOPYFLAGS',
    'D3D12_MESSAGE_ID_KEYEDMUTEX_WRONGSTATE',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_SYNC',
    'D3D12_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_INCOMPATIBLE_WITH_STRUCTURED_BUFFERS',
    'D3D12_MESSAGE_ID', 'DXGI_FORMAT_R8G8_SNORM',
    'D3D12_MESSAGE_ID_CREATE_VIDEOENCODERHEAP',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFUNC',
    'ID3D12Pageable', 'ID3D12Debug',
    'D3D12_MESSAGE_ID_UNMAP_INVALIDHEAP',
    'D3D12_MESSAGE_CATEGORY_SHADER', 'DXGI_FORMAT_B8G8R8A8_UNORM',
    'ID3D12Fence', 'D3D12_MESSAGE_ID_NODE_MASK_MISMATCH',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_UNRECOGNIZEDFORMAT',
    'D3D12_MESSAGE_ID_TOO_MANY_NODES_SPECIFIED',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALID_FLAGS',
    'D3D12_MESSAGE_ID_LIVE_PROTECTED_RESOURCE_SESSION',
    'D3D12_MESSAGE_ID_DESTROY_TRACKEDWORKLOAD',
    'DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS',
    'D3D12_MESSAGE_ID_COMMAND_LIST_SYNC',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDFORMAT',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_CONTENTION',
    'D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_CREATEDEVICE_INVALIDARGS',
    'D3D12_MESSAGE_ID_MAP_INVALID_NULLRANGE',
    'D3D12_MESSAGE_ID_DESTROY_VIDEODECODECOMMANDLIST',
    'D3D12_MESSAGE_ID_DATA_STATIC_DESCRIPTOR_INVALID_DATA_CHANGE',
    'D3D12_MESSAGE_ID_CREATE_META_COMMAND',
    'D3D12_MESSAGE_ID_LIVE_HEAP',
    'D3D12_MESSAGE_ID_DESTROY_META_COMMAND',
    'DXGI_FORMAT_R8G8B8A8_UINT',
    'D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDSUBRESOURCE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_MATCHING_STATES',
    'D3D12_MESSAGE_ID_SET_SCISSOR_RECTS_INVALID_RECT',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBIGNORED',
    'D3D12_MESSAGE_ID_DESTROY_SHADERCACHESESSION',
    'ID3D12DeviceChild',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCRESOURCEDIMENSION',
    'D3D12_HEAP_FLAG_NONE',
    'D3D12_MESSAGE_ID_OBJECT_DELETED_WHILE_STILL_IN_USE',
    'D3D12_MESSAGE_SEVERITY_CORRUPTION',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDCLEARVALUE',
    'D3D12_MESSAGE_ID_CREATE_PIPELINESTATE',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_OPENCOMMANDLIST',
    'D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_FLAGS', 'DXGI_FORMAT_YUY2',
    'D3D12_MESSAGE_ID_RSSETSHADING_RATE_INVALID_COMBINER',
    'D3D12_MESSAGE_ID_COMMAND_QUEUE_TOO_MANY_SWAPCHAIN_REFERENCES',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOEXTENSIONCOMMAND',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_SRC_RANGE_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_SET_RENDER_TARGETS_INVALID',
    'D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_TYPE',
    'D3D12_DEBUG_COMMAND_LIST_PARAMETER_GPU_BASED_VALIDATION_SETTINGS',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_MISMATCH_ENCODE_REFERENCE_ONLY_FLAG',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_TRAILING_DIGIT_IN_SEMANTIC',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_NULLSRC',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_NOT_SET',
    'D3D12_INFO_QUEUE_FILTER_DESC', 'DXGI_FORMAT_R16G16_UNORM',
    'D3D12_MESSAGE_ID_KEYEDMUTEX_INVALIDOBJECT',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_TYPE',
    'D3D12_MESSAGE_ID_ENCODE_FRAME_UNSUPPORTED_PARAMETERS',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDLIST12',
    'D3D12_HEAP_FLAG_ALLOW_WRITE_WATCH',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_STRIDE_UNALIGNED',
    'D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_DEFERRED',
    'D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_RECORDTIME_ASSUMEDFROMFIRSTUSE',
    'D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDFORMAT',
    'D3D12_MESSAGE_ID_SET_DESCRIPTOR_HEAP_INVALID',
    'D3D12_MESSAGE_ID_COMMAND_LIST_SETRENDERTARGETS_INVALIDNUMRENDERTARGETS',
    'D3D12_CPU_PAGE_PROPERTY_UNKNOWN',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER5',
    'DXGI_FORMAT_R32G8X24_TYPELESS',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER2',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDESC',
    'D3D12_MESSAGE_ID_CREATE_DESCRIPTOR_HEAP_LARGE_NUM_DESCRIPTORS',
    'D3D12_MEMORY_POOL_L0', 'DXGI_FORMAT_BC5_UNORM',
    'DXGI_FORMAT_R16_UINT',
    'D3D12_MESSAGE_ID_RENDER_PASS_MISMATCHING_NO_ACCESS',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDBOX',
    'D3D12_RESOURCE_FLAG_RAYTRACING_ACCELERATION_STRUCTURE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_REPEATEDOUTPUT',
    'D3D12_MESSAGE_ID_LIVE_COMMANDQUEUE',
    'D3D12_MESSAGE_ID_ENQUEUE_MAKE_RESIDENT_INVALID_FLAGS',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_OUTOFMEMORY_RETURN',
    'DXGI_FORMAT_R32_UINT', 'DXGI_FORMAT_R8G8B8A8_UNORM_SRGB',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_MINPRECISION',
    'DXGI_FORMAT_Y210',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCFORMAT',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DST_RESOURCE',
    'D3D12_RESOURCE_FLAG_ALLOW_SIMULTANEOUS_ACCESS',
    'DXGI_FORMAT_R16G16B16A16_UINT',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_MISSINGELEMENT',
    'D3D12_MESSAGE_ID_GETGPUVIRTUALADDRESS_INVALID_RESOURCE_DIMENSION',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER14',
    'D3D12_MESSAGE_ID_GETCUSTOMHEAPPROPERTIES_UNRECOGNIZEDHEAPTYPE',
    'D3D12_MESSAGE_ID_META_COMMAND_INVALID_GPU_VIRTUAL_ADDRESS',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_NULLDST',
    'DXGI_FORMAT_B8G8R8A8_TYPELESS',
    'D3D12_HEAP_FLAG_ALLOW_ONLY_RT_DS_TEXTURES',
    'D3D12_MESSAGE_ID_CREATESHAREDRESOURCE_INVALIDFORMAT',
    'D3D12_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_INVALID',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_DECODE_HEAP_CAPS_FAILURE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_BEGIN_END',
    'D3D12_DEBUG_DEVICE_PARAMETER_TYPE',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_OUTOFMEMORY',
    'DXGI_FORMAT_BC4_UNORM',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDHEAPPROPERTIES',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTCOORDINATES',
    'DXGI_FORMAT_BC4_TYPELESS',
    'D3D12_MESSAGE_ID_GETCUSTOMHEAPPROPERTIES_INVALIDHEAPTYPE',
    'D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_USE_OF_ZERO_REFCOUNT_OBJECT',
    'D3D12_MESSAGE_ID_WINDOWS7_FENCE_OUTOFORDER_WAIT',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DEPENDENT_SUBRESOURCE_RANGES',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DEPENDENT_SUBRESOURCE_RANGE',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_HEAP_UNSUPPORTED_PARAMETERS',
    'DXGI_FORMAT_R16_FLOAT',
    'D3D12_MESSAGE_ID_ALPHA_BLEND_FACTOR_NOT_SUPPORTED',
    'DXGI_FORMAT_R16G16B16A16_SINT',
    'D3D12_MESSAGE_ID_CREATE_VIDEOEXTENSIONCOMMAND',
    'D3D12_MESSAGE_ID_CAST_TO_PLANAR_NOT_SUPORTED',
    'DXGI_FORMAT_BC7_UNORM_SRGB',
    'D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_INVALIDOBJECT',
    'D3D12_MESSAGE_ID_ESTIMATE_MOTION_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DST_RESOURCE_DIMENSION',
    'DXGI_FORMAT_R1_UNORM',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILZFAILOP',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOPALPHA',
    'D3D12_MESSAGE_ID_SETTING_SHADING_RATE_FROM_MS_REQUIRES_CAPABILITY',
    'D3D12_RESOURCE_DIMENSION_TEXTURE1D',
    'D3D12_MESSAGE_ID_RENDER_PASS_MISMATCHING_SUSPEND_RESUME',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_LIVE_PIPELINESTATE',
    'D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERTYPE',
    'DXGI_FORMAT_BC6H_TYPELESS',
    'D3D12_MESSAGE_ID_EXECUTE_BUNDLE_TYPE',
    'D3D12_MESSAGE_ID_RENDER_TARGET_SAMPLE_DESC_MISMATCH_PIPELINE_STATE',
    'D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_UAVSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_REGISTERMASK',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INPUTLAYOUT_NOT_SET',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_DUPLICATE_SUBRESOURCE_TRANSITIONS',
    'D3D12_MESSAGE_ID_LIVE_VIDEOMOTIONESTIMATOR',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDENTRIES',
    'D3D12_MESSAGE_ID_CREATE_COMMANDLIST12',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFORMAT',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_CREATE_SAMPLER_INVALID',
    'D3D12_MESSAGE_ID_BUFFER_BARRIER_SUBREGION_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_CREATE_CRYPTO_SESSION_POLICY',
    'D3D12_MESSAGE_CATEGORY_MISCELLANEOUS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_SEMANTICNAME_NOT_FOUND',
    'D3D12_MESSAGE_ID_CREATE_RESOURCE',
    'D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALIDHEAPMISCFLAGS',
    'D3D12_MESSAGE_ID_EXECUTE_BUNDLE_STATIC_DESCRIPTOR_DATA_STATIC_NOT_SET',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_DEPTHSTENCILVIEW_NOT_SET',
    'D3D12_MESSAGE_ID_META_COMMAND_PARAMETER_SIZE_MISMATCH',
    'DXGI_FORMAT_R32_FLOAT', 'DXGI_FORMAT_R8_UINT',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_MISMATCH_DECODE_REFERENCE_ONLY_FLAG',
    'DXGI_FORMAT_R11G11B10_FLOAT',
    'D3D12_HEAP_FLAG_DENY_NON_RT_DS_TEXTURES',
    'D3D12_MESSAGE_ID_REFLECTSHAREDPROPERTIES_INVALIDSIZE',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INCOMPATIBLEFORMAT',
    'DXGI_FORMAT_BC1_TYPELESS',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_COMMANDLISTMISMATCH',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_MIP_REGION',
    'D3D12_MESSAGE_ID_COPYRESOURCE_MISMATCH_ENCODE_REFERENCE_ONLY_FLAG',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILZFAILOP',
    'D3D12_MESSAGE_ID_CREATE_VIDEOENCODECOMMANDQUEUE',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOTCLASSCHANGE',
    'D3D12_MESSAGE_ID_BEGIN_END_EVENT_MISMATCH',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_TRANSCODE_INVALID_FORMAT',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DECLTOOCOMPLEX',
    'D3D12_MESSAGE_ID_SET_STREAM_OUTPUT_BUFFERS_INVALID',
    'D3D12_MESSAGE_ID_VIEW_INSTANCING_INVALIDARGS',
    'D3D12_MESSAGE_ID_MAP_INVALIDRESOURCE',
    'D3D12_RESOURCE_FLAG_ALLOW_DEPTH_STENCIL',
    'D3D12_MESSAGE_ID_DESCRIPTOR_HEAP_NOT_SHADER_VISIBLE',
    'DXGI_FORMAT_R32_SINT',
    'D3D12_MESSAGE_ID_GET_PIPELINE_STACK_SIZE_ERROR',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER8',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_STOREPIPELINE_NONAME', 'DXGI_FORMAT_P208',
    'D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_INVALID_DEST',
    'DXGI_FORMAT_B8G8R8X8_UNORM_SRGB',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER10',
    'D3D12_MESSAGE_CATEGORY_RESOURCE_MANIPULATION',
    'D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_UAVSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_OUTOFMEMORY_RETURN',
    'D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_CS_ROOT_SIGNATURE_MISMATCH',
    'DXGI_FORMAT_R8G8_UNORM', 'D3D12_MESSAGE_ID_CREATEHEAP_NULLDESC',
    'DXGI_FORMAT_R16G16_UINT', 'DXGI_FORMAT_BC3_TYPELESS',
    'DXGI_FORMAT_BC6H_UF16',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDCPUPAGEPROPERTIES',
    'ID3D12InfoQueue', 'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_TYPE',
    'D3D12_MESSAGE_ID_CREATEHEAP_INVALIDARG_RETURN',
    'D3D12_MESSAGE_ID_SET_ROOT_SHADER_RESOURCE_VIEW_INVALID',
    'DXGI_FORMAT_R16_SNORM',
    'D3D12_MESSAGE_ID_BEGIN_END_QUERY_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CLEARRENDERTARGETVIEW_MISMATCHINGCLEARVALUE',
    'D3D12_MESSAGE_ID_DEPTH_STENCIL_SAMPLE_DESC_MISMATCH_PIPELINE_STATE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDSRCFORMAT',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TYPE_MISMATCH',
    'DXGI_FORMAT_R16G16B16A16_TYPELESS',
    'DXGI_FORMAT_R16G16B16A16_UNORM',
    'D3D12_HEAP_FLAG_ALLOW_ONLY_NON_RT_DS_TEXTURES', 'ID3D12Debug2',
    'D3D12_MESSAGE_ID_GETRESOURCEALLOCATIONINFO_INVALIDRDESCS',
    'D3D12_MESSAGE_ID_CREATE_VIDEODECODECOMMANDLIST',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HULL_SHADER_INPUT_TOPOLOGY_MISMATCH',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_DIMENSION',
    'D3D12_DEBUG_FEATURE_DISABLE_VIRTUALIZED_BUNDLES_VALIDATION',
    'DXGI_FORMAT_BC1_UNORM_SRGB',
    'D3D12_MESSAGE_ID_VIDEO_PROCESS_SUPPORT_UNSUPPORTED_FORMAT',
    'D3D12_MESSAGE_ID_PROCESS_FRAME_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_DISABLED',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_ZERO_DEPENDENCIES',
    'D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_MISSING_ROOT_SIGNATURE',
    'D3D12_MESSAGE_ID_CREATEVERTEXSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSCOMMANDQUEUE',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DST',
    '__MIDL_IWinTypes_0009',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDFORMAT',
    'DXGI_FORMAT_BC7_TYPELESS', 'D3D12_MESSAGE_SEVERITY_WARNING',
    'D3D12_MESSAGE_CATEGORY_EXECUTION',
    'D3D12_MESSAGE_ID_DESTROY_PIPELINELIBRARY', 'DXGI_FORMAT_R8_SINT',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_COMPONENTTYPE',
    'D3D12_MESSAGE_ID_VERTEX_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCDSPLACEDFOOTPRINTFORMAT',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAGS_FOR_FORMAT',
    'D3D12_MESSAGE_ID_LIVE_COMMANDRECORDER',
    'D3D12_MESSAGE_ID_CREATE_HEAP',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDFORMAT',
    'D3D12_MESSAGE_ID_CREATE_COMMANDQUEUE', 'ID3D12DebugCommandList2',
    'D3D12_MESSAGE_ID_CREATE_VIDEOENCODECOMMANDLIST',
    'D3D12_RLDO_DETAIL',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_MISC_FLAGS',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_LAYOUT',
    'D3D12_MESSAGE_ID_ENHANCED_BARRIERS_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_DESTROY_VIDEODECODESTREAM',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_INVALID_COMMAND_LIST_TYPE_FOR_FEATURE_LEVEL',
    'D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_ADAPTERVERSIONMISMATCH',
    'D3D12_MESSAGE_ID_SETRESIDENCYPRIORITY_INVALID_PAGEABLE',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER15',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_BLENDOPALPHA_WARNING',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_LIVE_COMMANDSIGNATURE',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_STEPRATESLOTCLASSMISMATCH',
    'D3D12_MESSAGE_ID_LEGACY_BARRIER_VALIDATION_FORCED_ON',
    'D3D12_DEBUG_DEVICE_PARAMETER_FEATURE_FLAGS',
    'DXGI_FORMAT_SAMPLER_FEEDBACK_MIP_REGION_USED_OPAQUE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCRESOURCE',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDSLOPESCALEDDEPTHBIAS',
    'D3D12_MESSAGE_ID_DECODE_FRAME_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER9',
    'D3D12_MESSAGE_CATEGORY_STATE_CREATION',
    'D3D12_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_DEVICE_CLEARVIEW_EMPTYRECT',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOMOTIONVECTORHEAP',
    'D3D12_MESSAGE_ID_CHECK_DRIVER_MATCHING_IDENTIFIER_DRIVER_REPORTED_ISSUE',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOT',
    'D3D12_MESSAGE_ID_RESOURCE_FORMAT_REQUIRES_SAMPLER_FEEDBACK_CAPABILITY',
    'D3D12_MESSAGE_ID_RESOURCE_UNMAP_NOTMAPPED',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_EMPTY_LAYOUT',
    'D3D12_MESSAGE_ID_LIVE_CRYPTO_SESSION_POLICY',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_BEFORE_AFTER_MISMATCH',
    'D3D12_MESSAGE_ID_VIEW_INSTANCING_UNSUPPORTED',
    'DXGI_FORMAT_R16G16_FLOAT',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_DS_TESSELLATOR_DOMAIN_MISMATCH',
    'Library',
    'D3D12_MESSAGE_ID_CREATE_UNORDEREDACCESS_VIEW_INVALID_COUNTER_USAGE',
    'D3D12_MESSAGE_ID_LIVE_QUERYHEAP',
    'D3D12_MESSAGE_ID_ADD_TO_STATE_OBJECT_ERROR',
    'D3D12_MESSAGE_ID_RESOLVE_ENCODER_OUTPUT_METADATA_UNSUPPORTED_PARAMETERS',
    'D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_ARRAY_SIZE',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOMOTIONESTIMATOR',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_SAMPLE_COUNT',
    'D3D12_MESSAGE_ID_EMIT_RAYTRACING_ACCELERATION_STRUCTURE_POSTBUILD_INFO_INVALID',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_DEPENDENT_RESOURCES',
    'DXGI_FORMAT_Y410',
    'D3D12_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMBINATION',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSLOT',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_PRIMITIVETOPOLOGY',
    'D3D12_MESSAGE_ID_COPY_DESCRIPTORS_INVALID_RANGES',
    'D3D12_MESSAGE_ID_COMMAND_LIST_OUTOFMEMORY',
    'D3D12_MESSAGE_CATEGORY_APPLICATION_DEFINED',
    'D3D12_MESSAGE_ID_NO_GRAPHICS_API_SUPPORT',
    'D3D12_TEXTURE_LAYOUT_UNKNOWN', 'D3D12_DEBUG_FEATURE',
    'D3D12_MESSAGE_ID_DESTROY_VIDEODECODER',
    'D3D12_MESSAGE_ID_PROTECTED_RESOURCE_SESSION_UNSUPPORTED',
    'D3D12_MESSAGE_ID_LIVE_COMMANDALLOCATOR',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_USE_OF_CENTER_MULTISAMPLE_PATTERN',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VIEW_INSTANCING_VERTEX_SIZE_EXCEEDED',
    'D3D12_MESSAGE_ID_VIDEO_DECODE_FRAME_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_MISMATCHING_TARGETED_RESOURCE',
    'D3D12_MESSAGE_ID_UPDATETILEMAPPINGS_POSSIBLY_MISMATCHING_PROPERTIES',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_DESERIALIZE_FAILED',
    'D3D12_MESSAGE_ID_LIVE_VIDEODECODESTREAM',
    'D3D12_MESSAGE_ID_WRONG_COMMAND_ALLOCATOR_TYPE',
    'D3D12_MESSAGE_ID_SET_VERTEX_BUFFERS_INVALID',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALIDCACHEDBLOB',
    'D3D12_MESSAGE_ID_READFROMSUBRESOURCE_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_CACHEFULL',
    'D3D12_MESSAGE_ID_LIVE_COMMANDLIST12',
    'D3D12_MESSAGE_ID_DISCARD_ONE_SUBRESOURCE_FOR_MIPS_WITH_RECTS',
    'D3D12_MESSAGE_ID_RESOLVE_QUERY_DATA_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_LIVE_VIDEODECODECOMMANDLIST',
    'D3D12_MEMORY_POOL', 'D3D12_MESSAGE_ID_DEPRECATED_API',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_SRC_RESOURCE_DIMENSION',
    'D3D12_MESSAGE_ID_CREATECOMMANDLIST_NULL_COMMANDALLOCATOR',
    'DXGI_FORMAT_D32_FLOAT',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_QUEUE_INSUFFICIENT_HARDWARE_SUPPORT_FOR_GLOBAL_REALTIME',
    'D3D12_MESSAGE_ID_CREATEHEAP_INVALIDSIZE',
    'D3D12_MESSAGE_ID_UNSUPPORTED_BARRIER_LAYOUT', 'DXGI_FORMAT_V208',
    'D3D12_MESSAGE_SEVERITY_MESSAGE',
    'D3D12_MESSAGE_ID_MAP_OUTOFMEMORY_RETURN',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_UNMATCHED_BEGIN',
    'D3D12_MESSAGE_ID_LIVE_SWAPCHAIN',
    'D3D12_MESSAGE_ID_CREATEHEAP_INVALIDMISCFLAGS',
    'D3D12_DEBUG_FEATURE_CONSERVATIVE_RESOURCE_STATE_TRACKING',
    'DXGI_FORMAT_R8G8B8A8_TYPELESS',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTARTCOMPONENTANDCOMPONENTCOUNT',
    'D3D12_HEAP_FLAG_ALLOW_SHADER_ATOMICS',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_MS_INCOMPLETE_TYPE',
    'DXGI_FORMAT_R16G16B16A16_SNORM', 'ID3D12DebugCommandList',
    'D3D12_MESSAGE_ID_GETGPUVIRTUALADDRESS_INVALID_HEAP_TYPE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCOFFSET',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RTV_FORMAT_NOT_UNKNOWN',
    'D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDMEMORYPOOL',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_RENDER_TARGET_DOES_NOT_SUPPORT_BLENDING',
    'D3D12_MESSAGE_ID_RESOLVE_ENCODER_OUTPUT_METADATA_INVALID_PARAMETERS',
    'DXGI_FORMAT_P8',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_SET_ROOT_CONSTANT_INVALID',
    'D3D12_CPU_PAGE_PROPERTY_WRITE_COMBINE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDCOPYFLAGS',
    'D3D12_MESSAGE_ID_CREATE_VIDEODECODERHEAP',
    'D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_SETEVENTONMULTIPLEFENCECOMPLETION_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDIMENSIONALITY',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_UNRECOGNIZEDFORMAT',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_SRCREGIONOUTOFBOUNDS',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_POOL_INVALID_FLAGS',
    'D3D12_MESSAGE_ID_POSSIBLE_INVALID_USE_OF_NON_RESIDENT_RESOURCE',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_SAMPLE_COUNT',
    'D3D12_MESSAGE_ID_CAST_TARGET_TEXEL_SIZE_MISMATCH',
    'DXGI_FORMAT_BC5_TYPELESS',
    'D3D12_MESSAGE_ID_SETRESIDENCYPRIORITY_INVALID_PRIORITY',
    'D3D12_MESSAGE_ID_CREATESHAREDHEAP_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_OPENEXISTINGHEAP_INVALIDARG_RETURN',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFUNC',
    'D3D12_MESSAGE_ID_CREATE_VIDEODECODER',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_NOT_PS_MISMATCH',
    'D3D12_MESSAGE_ID_EMPTY_ROOT_DESCRIPTOR_TABLE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_STRIDE_TOO_SMALL',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DISPATCH_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_ZERO_SIZE_STREAM',
    'D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_HEAP_PROPERTIES', 'DXGI_FORMAT_R32G32B32A32_UINT',
    'DXGI_FORMAT_B8G8R8X8_UNORM',
    'D3D12_MESSAGE_ID_INVALID_DESCRIPTOR_HANDLE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_FORMATMISMATCH',
    'D3D12_MESSAGE_SEVERITY',
    'D3D12_MESSAGE_ID_LIVE_VIDEODECODECOMMANDQUEUE',
    'D3D12_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'DXGI_FORMAT_R16_TYPELESS',
    'D3D12_MESSAGE_ID_SET_INDEX_BUFFER_INVALID_DESC',
    'D3D12_MESSAGE_ID_BEGIN_EVENT', 'DXGI_FORMAT_V408',
    'D3D12_MESSAGE_ID_SHADERCACHECONTROL_STATEALREADYSET',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDDEPTHBIASCLAMP',
    'D3D12_MESSAGE_ID_LIVE_VIDEOENCODER', 'DXGI_FORMAT_Y216',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_METADATA_ERROR',
    'D3D12_RESOURCE_FLAG_ALLOW_UNORDERED_ACCESS',
    'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_SYNC',
    'DXGI_FORMAT_R9G9B9E5_SHAREDEXP',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDVIDEOPLANESLICE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTDIMENSIONS',
    'D3D12_MESSAGE_ID_CREATE_CRYPTO_SESSION',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_NULLDST',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_SHADERCACHEDELETE_NOTSUPPORTED',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DEPENDENT_SUBRESOURCE_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTROWPITCH',
    'DXGI_FORMAT_BC2_TYPELESS',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_ROOT_DESCRIPTOR_ACCESS_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_UNMAP_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_DESTROY_CRYPTO_SESSION_POLICY',
    'D3D12_MESSAGE_ID_KEYEDMUTEX_INVALIDKEY',
    'D3D12_MESSAGE_ID_CREATERASTERIZERSTATE_INVALID_CONSERVATIVERASTERMODE',
    'D3D12_MESSAGE_ID_VIDEO_DECODE_SUPPORT_INVALID_INPUT',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RENDERTARGETVIEW_NOT_SET',
    'D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSCOMMANDLIST',
    'D3D12_MESSAGE_ID_SETPRIVATEDATA_CHANGINGPARAMS',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDESC',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UAVSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_TIMESTAMPS_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_CREATE_DESCRIPTORHEAP',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_MORE_RECORDERS_THAN_LOGICAL_PROCESSORS',
    'D3D12_MESSAGE_ID_COPYRESOURCE_MISMATCH_DECODE_REFERENCE_ONLY_FLAG',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_NULL_ARGUMENTS',
    'D3D12_MESSAGE_ID_MAKERESIDENT_NULLOBJECTARRAY',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DEPENDENT_RANGE_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDDSTFORMAT',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_INVALID_FLAGS',
    'D3D12_MESSAGE_CATEGORY_COMPILATION',
    'D3D12_MESSAGE_ID_COPYRESOURCE_NULLSRC',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_UNSUPPORTEDFORMAT',
    'D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_AT_FAULT',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_FAILEDCOMMANDLIST',
    'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_LAYOUT',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_BUFFER_OFFSET',
    'D3D12_RLDO_SUMMARY',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_RESOURCE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_CONSTANT_BUFFER_VIEW_INVALID_RESOURCE',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_DST_RANGE_OUT_OF_BOUNDS',
    'D3D12_HEAP_FLAG_ALLOW_DISPLAY',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_AS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_ALL_RENDER_TARGETS_HAVE_UNKNOWN_FORMAT',
    'D3D12_MESSAGE_ID_PROGRAMMABLE_MSAA_UNSUPPORTED',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_EMPTYBOX',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDSIGNATURE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_STATIC_DESCRIPTOR_RESOURCE_DIMENSION_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDINPUTSLOTCLASS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_RUNTIME_INTERNAL_ERROR',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDMIPLEVELS',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_UNKNOWN_SUBOBJECT',
    'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_RESOURCE_DIMENSION',
    'D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_PIPELINELIBRARY',
    'D3D12_RESOURCE_DIMENSION_TEXTURE3D',
    'D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_UAVSNOTSUPPORTED',
    'DXGI_FORMAT_D32_FLOAT_S8X24_UINT',
    'D3D12_MESSAGE_ID_INVALID_BUNDLE_API',
    'D3D12_MESSAGE_ID_DESTROY_VIDEODECODECOMMANDQUEUE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_TOO_SMALL',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMMAND_LIST_TYPE',
    'D3D12_MESSAGE_ID_RENDER_PASS_DISALLOWED_API_CALLED',
    'D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_DRIVERVERSIONMISMATCH',
    'D3D12_MESSAGE_ID_LIVE_SHADERCACHESESSION',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_RESOURCE_ACCESS_OUT_OF_BOUNDS',
    'DXGI_FORMAT_R8G8_TYPELESS',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEFLOATOPSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_ONLYONEELEMENTPERSLOT',
    'D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDHEAPTYPE',
    'D3D12_DEBUG_FEATURE_NONE', 'D3D12_RESOURCE_DESC',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDHEAPMISCFLAGS',
    'DXGI_FORMAT_R16G16_SINT',
    'D3D12_MESSAGE_ID_CREATEQUERY_HEAP_VIDEO_DECODE_STATISTICS_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_DS_CONTROL_POINT_COUNT_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILPASSOP',
    'D3D12_MESSAGE_ID_LIVE_VIDEOENCODERHEAP',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDESC',
    'D3D12_MESSAGE_ID_CREATEPIXELSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_MAP_INVALIDARG_RETURN',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDRENDERTARGETWRITEMASK',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_CREATE_UAV_REQUIRES_FEEDBACK_MAP_FORMAT',
    'D3D12_MESSAGE_ID_PIPELINE_STATE_TYPE_MISMATCH',
    'D3D12_MESSAGE_ID_STATIC_DESCRIPTOR_INVALID_DESCRIPTOR_CHANGE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_PIPELINE_STATE_NOT_SET',
    'DXGI_FORMAT_R8_SNORM',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_INDEX_BUFFER_PROPERTIES',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCROWPITCH',
    'D3D12_MESSAGE_ID_COPY_DESCRIPTORS_WRITE_ONLY_DESCRIPTOR',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_RESOURCE',
    'D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDCPUPAGEPROPERTIES',
    'D3D12_MESSAGE_ID_SET_INDEX_BUFFER_INVALID',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_NULLDST',
    'D3D12_MESSAGE_ID_INVALID_NODE_INDEX',
    'DXGI_FORMAT_R32G32B32_UINT', 'D3D12_HEAP_FLAG_CREATE_NOT_ZEROED',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOENCODECOMMANDLIST',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATECOMPUTEPIPELINESTATE_INVALID_SHADER',
    'DXGI_FORMAT_SAMPLER_FEEDBACK_MIN_MIP_OPAQUE',
    'D3D12_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATE_COMMANDPOOL',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDSRCRESOURCEDIMENSION',
    'D3D12_RESOURCE_DIMENSION_TEXTURE2D',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_NULL_SRC',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_ZERO_BARRIERS',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDPLANESLICE',
    'D3D12_RESOURCE_FLAG_VIDEO_ENCODE_REFERENCE_ONLY',
    'D3D12_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'DXGI_FORMAT_R8G8B8A8_SINT',
    'D3D12_MESSAGE_ID_CREATE_QUEUE_VIDEO_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_CREATEMESHSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLENDALPHA',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOENCODER',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_QUEUE_INSUFFICIENT_PRIVILEGE_FOR_GLOBAL_REALTIME',
    'D3D12_RESOURCE_FLAG_ALLOW_CROSS_ADAPTER',
    'D3D12_MESSAGE_ID_CREATEDOMAINSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_UNINITIALIZED_META_COMMAND',
    'D3D12_MESSAGE_ID_COPYRESOURCE_INVALIDSRCRESOURCE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_VIDEOMOTIONVECTORHEAP', 'ID3D12Object',
    'D3D12_MESSAGE_ID_LIVE_LIBRARY', 'DXGI_FORMAT_UNKNOWN',
    'D3D12_MESSAGE_CATEGORY',
    'D3D12_MESSAGE_ID_SET_STREAM_OUTPUT_BUFFERS_INVALID_DESC',
    'D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDSUBRESOURCE',
    'D3D12_MESSAGE_ID_POSSIBLY_INVALID_SUBRESOURCE_STATE',
    'DXGI_FORMAT_R32G32_FLOAT',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLEND',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_TYPE_MISMATCH',
    'D3D12_MESSAGE_ID_META_COMMAND_FAILED_ENUMERATION',
    'D3D12_MESSAGE_ID_LIVE_VIDEOENCODECOMMANDQUEUE',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFORMAT',
    'D3D12_RESOURCE_DIMENSION',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAGS',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALID_DST_RESOURCE',
    'D3D12_MESSAGE_ID_BUILD_RAYTRACING_ACCELERATION_STRUCTURE_INVALID',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER7', 'typelib_path',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_DS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSCOMMANDLIST',
    'D3D12_MESSAGE_ID_RENDER_PASS_NO_SUBSEQUENT_RESUME_WITHIN_EXECUTECOMMANDLISTS',
    'D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER1',
    'D3D12_MESSAGE_ID_LIVE_COMMANDPOOL',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOENCODERHEAP',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_UNSUPPORTED',
    'D3D12_MESSAGE_ID_INCOMPATIBLE_BARRIER_ACCESS',
    'D3D12_MESSAGE_ID_RENDER_PASS_UNSUPPORTED_RESOLVE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTRIDES',
    'DXGI_FORMAT_B4G4R4A4_UNORM',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER11',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALID_FORMAT',
    'DXGI_FORMAT_R32G32B32_TYPELESS',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFAILOP',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTRESOURCEDIMENSION',
    'D3D12_MESSAGE_ID_CREATEHULLSHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSOR',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_DEPENDENT_RESOURCE',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDIMENSIONS',
    'D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_SHADER_RESOURCE_VIEW_NOT_SET',
    'D3D12_MESSAGE_ID_RENDER_PASS_NO_PRIOR_SUSPEND_WITHIN_EXECUTECOMMANDLISTS',
    'D3D12_RESOURCE_FLAG_ALLOW_RENDER_TARGET',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDQUEUE',
    'D3D12_MESSAGE_ID_LIVE_LIFETIMETRACKER',
    'D3D12_MESSAGE_ID_SHADING_RATE_SOURCE_REQUIRES_DIMENSION_TEXTURE2D',
    'DXGI_FORMAT_BC3_UNORM', 'D3D12_MESSAGE_CALLBACK_FLAG_NONE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_FLAG',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_UNPARSEABLEINPUTSIGNATURE',
    'DXGI_FORMAT', 'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER3',
    'D3D12_MESSAGE_ID_INVALID_VIDEO_EXTENSION_COMMAND_ID',
    'D3D12_MESSAGE_ID_GETCOPYABLELAYOUT_INVALIDBASEOFFSET',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDIMENSIONS',
    'ID3D12SharingContract', 'DXGI_FORMAT_R32G32B32_FLOAT',
    'D3D12_MESSAGE_ID_SET_VERTEX_BUFFERS_INVALID_DESC',
    'D3D12_HEAP_FLAG_ALLOW_ONLY_BUFFERS',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_MISMATCHING_COMMAND_LIST_TYPE',
    'D3D12_MESSAGE_ID_RENDER_PASS_GPU_WORK_WHILE_SUSPENDED',
    'DXGI_FORMAT_R24G8_TYPELESS',
    'D3D12_MESSAGE_ID_CREATE_PROTECTED_RESOURCE_SESSION',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMENTRIES',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCOMPONENTCOUNT',
    'D3D12_MESSAGE', 'D3D12_MESSAGE_ID_COMMAND_POOL_SYNC',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTFORMAT',
    'D3D12_MESSAGE_ID_SET_DESCRIPTOR_TABLE_INVALID',
    'D3D12_MESSAGE_ID_WRITETOSUBRESOURCE_INVALIDBOX',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_REQUIRES_UNORDERED_ACCESS_FLAG',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDIMENSIONS',
    'D3D12_MESSAGE_ID_LIVE_TRACKEDWORKLOAD',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_UNSUPPORTED_PARAMETERS',
    'D3D12_MEMORY_POOL_UNKNOWN',
    'D3D12_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_NOT_AT_FAULT',
    'D3D12_MESSAGE_ID_DESCRIPTOR_HANDLE_WITH_INVALID_RESOURCE',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_RESERVED_BITS',
    'D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_INVALIDLIBRARYBLOB',
    'D3D12_MESSAGE_ID_OUT_OF_ORDER_TRACKED_WORKLOAD_PAIR',
    'D3D12_MESSAGE_ID_EMPTY_DISPATCH',
    'D3D12_MESSAGE_ID_CREATE_SHADERCACHESESSION',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CREATEQUERY_HEAP_COPY_QUEUE_TIMESTAMPS_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_CREATEHULLSHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_DISCARD_NO_RECTS_FOR_NON_TEXTURE2D',
    'D3D12_MESSAGE_ID_LIVE_META_COMMAND',
    'D3D12_MESSAGE_ID_GET_SHADER_STACK_SIZE_ERROR',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DESCRIPTOR_TABLE_NOT_SET',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_RENDER_TARGET_DOES_NOT_SUPPORT_LOGIC_OPS',
    'D3D12_MESSAGE_ID_STOREPIPELINE_DUPLICATENAME',
    'D3D12_HEAP_FLAG_SHARED', 'D3D12_HEAP_TYPE_DEFAULT',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_HS_DS_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_OM_DUAL_SOURCE_BLENDING_CAN_ONLY_HAVE_RENDER_TARGET_0',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERBYTECODE',
    'D3D12_MESSAGE_ID_SAMPLER_FEEDBACK_MAP_INVALID_SAMPLE_QUALITY',
    'D3D12_MESSAGE_ID_DESTROY_CRYPTO_SESSION',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDGAPDEFINITION',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFORMAT',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLEND',
    'DXGI_FORMAT_R8_UNORM',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDDIMENSIONS',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_NON_RETAIL_SHADER_MODEL_WONT_VALIDATE',
    'D3D12_DEBUG_FEATURE_ALLOW_BEHAVIOR_CHANGING_DEBUG_AIDS',
    'D3D12_MESSAGE_ID_SETPRIVATEDATA_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_RENDER_TARGET_COUNT',
    'D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_UAVSNOTSUPPORTED',
    'DXGI_FORMAT_R32G32_UINT',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOP',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_BUNDLENOTSUPPORTED',
    'D3D12_MESSAGE_ID_GET_SHADER_IDENTIFIER_ERROR',
    'D3D12_MESSAGE_ID_LIVE_PIPELINELIBRARY',
    'D3D12_MESSAGE_ID_BUNDLE_PIPELINE_STATE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_CREATE_CONSTANT_BUFFER_VIEW_INVALID_DESC',
    'D3D12_MESSAGE_ID_OPENEXISTINGHEAP_OUTOFMEMORY_RETURN',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_UNRECOGNIZEDFORMAT',
    'D3D12_MESSAGE_ID_READFROMSUBRESOURCE_EMPTYBOX',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_NULL_RESOURCE_DESC',
    'D3D12_HEAP_FLAG_DENY_BUFFERS',
    'D3D12_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_CANNOT_RESET_COMMAND_POOL_WITH_OPEN_COMMAND_LISTS',
    'ID3D12Debug1',
    'D3D12_MESSAGE_ID_WRITEBUFFERIMMEDIATE_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_GS_ROOT_SIGNATURE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATE_COMMANDRECORDER',
    'D3D12_MESSAGE_ID_PIPELINELIBRARY_SERIALIZE_NOTENOUGHMEMORY',
    'D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_SAMPLE_QUALITY',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MS_PSO_DESC_MISMATCH',
    'D3D12_MESSAGE_ID_RSSETSHADING_RATE_INVALID_SHADING_RATE',
    'D3D12_MESSAGE_ID_TRACKED_WORKLOAD_NOT_SUPPORTED',
    'DXGI_FORMAT_X24_TYPELESS_G8_UINT',
    'D3D12_MESSAGE_ID_SHADERCACHECONTROL_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_SUBRESOURCE',
    'ID3D12DebugDevice1', 'DXGI_FORMAT_P016',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_UNBOUNDED_STATIC_DESCRIPTORS',
    'D3D12_MESSAGE_ID_DESTROY_DESCRIPTORHEAP', 'ID3D12DebugDevice2',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_OUTPUTEXCEEDSMAXSIZE',
    'D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSCOMMANDQUEUE',
    'D3D12_MESSAGE_ID_VIDEO_CREATE_MOTION_VECTOR_HEAP_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDVIDEOPLANESLICE',
    'D3D12_MESSAGE_ID_RESOLVE_MOTION_VECTOR_HEAP_INVALID_ARGUMENT',
    'D3D12_MESSAGE_CALLBACK_FLAGS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_OUTPUT_TYPE_MISMATCH',
    'D3D12_MESSAGE_ID_COMMAND_LIST_STATIC_DESCRIPTOR_SAMPLER_MODE_MISMATCH',
    'DXGI_FORMAT_R10G10B10A2_UNORM', 'DXGI_FORMAT_BC3_UNORM_SRGB',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER13',
    'D3D12_MESSAGE_ID_COMMAND_LIST_ROOT_UNORDERED_ACCESS_VIEW_NOT_SET',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_SRC_RESOURCE',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INPUTLAYOUT_SHADER_MISMATCH',
    'D3D12_DEBUG_FEATURE_EMULATE_WINDOWS7',
    'DXGI_FORMAT_R32G32B32A32_FLOAT',
    'D3D12_MESSAGE_ID_DEVICE_OPEN_SHARED_HANDLE_ACCESS_DENIED',
    'DXGI_FORMAT_D24_UNORM_S8_UINT',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_UNRECOGNIZEDSRCTYPE',
    'D3D12_MESSAGE_ID_VIDEO_DECODE_SUPPORT_UNSUPPORTED',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_COMBINED_FLAGS',
    'D3D12_MESSAGE_ID_DESTROY_RESOURCE',
    'D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_END_WITHOUT_BEGIN',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATE_VIDEOENCODER',
    'D3D12_MESSAGE_ID_CLEAR_UNORDERED_ACCESS_VIEW_INVALID_DESCRIPTOR_HANDLE',
    'D3D12_MESSAGE_CATEGORY_INITIALIZATION',
    'D3D12_MESSAGE_ID_VIDEO_PROCESS_FRAMES_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_RENDER_PASS_INVALID_RESOURCE_BARRIER',
    'D3D12_MESSAGE_ID_CREATE_QUERYHEAP',
    'D3D12_MESSAGE_ID_CREATEHEAP_INVALIDALIGNMENT',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTRESOURCE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTDSPLACEDFOOTPRINTFORMAT',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CANNOT_DEDUCE_TYPE',
    'DXGI_FORMAT_R24_UNORM_X8_TYPELESS',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_GPU_WRITTEN_READBACK_RESOURCE_MAPPED',
    'D3D12_MESSAGE_ID_GET_SHADER_IDENTIFIER_SIZE_INVALID',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDSAMPLEDESC',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILPASSOP',
    'D3D12_MESSAGE_ID_STRING_FROM_APPLICATION',
    'D3D12_MESSAGE_ID_META_COMMAND_ID_INVALID',
    'D3D12_MESSAGE_ID_SETVIEWINSTANCEMASK_INVALIDARGS',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_NOT_UNIQUE_IN_DXIL_LIBRARY',
    'D3D12_MESSAGE_ID_EXECUTE_BUNDLE_OPEN_BUNDLE',
    'D3D12_MESSAGE_ID_LIVE_DESCRIPTORHEAP',
    'D3D12_MESSAGE_ID_DESTROY_MONITOREDFENCE',
    'D3D12_MESSAGE_ID_MAP_INVALIDHEAP',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_NULL_POINTER',
    'D3D12_MESSAGE_ID_MAP_INVALIDSUBRESOURCE',
    'D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_CLOSE_COMMAND_LIST',
    'D3D12_MESSAGE_ID_LIVE_VIDEOPROCESSSTREAM',
    'D3D12_MESSAGE_ID_SET_BACKGROUND_PROCESSING_MODE_INVALID_ARGUMENT',
    'D3D12_MESSAGE_ID_INCOMPLETE_TRACKED_WORKLOAD_PAIR',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_ENCODER_HEAP_INVALID_PARAMETERS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_GS_INPUT_PRIMITIVE_MISMATCH',
    'ID3D12Debug6', 'DXGI_FORMAT_NV11',
    'D3D12_MESSAGE_CATEGORY_STATE_GETTING',
    'D3D12_MESSAGE_ID_GETPRIVATEDATA_MOREDATA',
    'D3D12_MESSAGE_ID_SHADERCACHECONTROL_IGNOREDFLAG',
    'DXGI_FORMAT_A8P8', 'D3D12_MESSAGE_ID_LIVE_VIDEOEXTENSIONCOMMAND',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_USAGE_WITH_CREATECOMMANDLIST1_COMMAND_LIST',
    'D3D12_MESSAGE_ID_LIVE_ROOTSIGNATURE',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDESC',
    'D3D12_HEAP_FLAG_ALLOW_ALL_BUFFERS_AND_TEXTURES',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDVIDEOPLANESLICE',
    'D3D12_MESSAGE_ID_GET_RAYTRACING_ACCELERATION_STRUCTURE_PREBUILD_INFO_INVALID',
    'D3D12_MESSAGE_CATEGORY_STATE_SETTING',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSTREAMSTRIDEUNUSED',
    'D3D12_RESOURCE_FLAGS', 'ID3D12DebugCommandQueue',
    'D3D12_TEXTURE_LAYOUT_64KB_UNDEFINED_SWIZZLE',
    'D3D12_MESSAGE_ID_COMMAND_ALLOCATOR_RESET_BUNDLE',
    'D3D12_MESSAGE_ID_MULTIPLE_TRACKED_WORKLOAD_PAIRS',
    'D3D12_RESOURCE_FLAG_VIDEO_DECODE_REFERENCE_ONLY',
    'D3D12_MESSAGE_ID_CREATEHEAP_UNRECOGNIZEDMISCFLAGS',
    'D3D12_MESSAGE_ID_CORRUPTED_PARAMETER12',
    'D3D12_MESSAGE_ID_CREATE_TRACKEDWORKLOAD',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_INVALID_COMMAND_LIST_TYPE',
    'DXGI_FORMAT_R8G8_B8G8_UNORM', 'ID3D12DebugCommandList1',
    'D3D12_MESSAGE_ID_COMMAND_RECORDER_CONTENTION',
    'D3D12_MESSAGE_ID_MESH_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE',
    'D3D12_MESSAGE_ID_CREATE_QUEUE_INVALID_PRIORITY',
    'D3D12_MESSAGE_ID_EXECUTE_BUNDLE_DESCRIPTOR_HEAP_MISMATCH',
    'D3D12_MESSAGE_ID_CREATERESOURCE_UNRECOGNIZEDCLEARVALUEFORMAT',
    'D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_FORMAT',
    'D3D12_MESSAGE_ID_NO_COMPUTE_API_SUPPORT',
    'DXGI_FORMAT_B8G8R8A8_UNORM_SRGB',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_INVALID_HEAP',
    'D3D12_MESSAGE_ID_TRACKED_WORKLOAD_COMMAND_QUEUE_MISMATCH',
    'D3D12_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEFLOATOPSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFAILOP',
    'DXGI_FORMAT_R8G8_UINT',
    'D3D12_TEXTURE_LAYOUT_64KB_STANDARD_SWIZZLE',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSOR',
    'D3D12_MESSAGE_ID_INVALID_SUBRESOURCE_STATE',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSTREAMSTRIDE',
    'D3D12_MESSAGE_ID_CREATE_COMMANDALLOCATOR',
    'D3D12_MESSAGE_ID_CREATE_ROOT_SIGNATURE_BLOB_NOT_FOUND',
    'D3D12_MESSAGE_ID_CANNOT_CHANGE_COMMAND_RECORDER_TARGET_WHILE_RECORDING',
    'D3D12_MESSAGE_ID_DEPTH_STENCIL_FORMAT_MISMATCH_PIPELINE_STATE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INDEX_BUFFER_NOT_SET',
    'DXGI_FORMAT_R16G16_TYPELESS',
    'D3D12_MESSAGE_ID_MESSAGE_REPORTING_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_LIVE_DEVICE',
    'D3D12_MESSAGE_ID_LIVE_MONITOREDFENCE',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_BLENDOP_WARNING',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_SAMPLER_MODE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDPLANESLICE',
    'D3D12_MESSAGE_ID_COMMAND_RECORDER_SUPPORT_FLAGS_MISMATCH',
    'D3D12_MESSAGE_ID_COPYBUFFERREGION_INVALIDDSTRESOURCEDIMENSION',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_MESSAGE_ID_HEAP_ADDRESS_RANGE_INTERSECTS_MULTIPLE_BUFFERS',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGSEMANTIC',
    'D3D12_MESSAGE_ID_DISPATCH_RAYS_INVALID',
    'D3D12_RESOURCE_FLAG_NONE',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_UNRECOGNIZEDMEMORYPOOL',
    'D3D12_MESSAGE_ID_CREATEPLACEDRESOURCEONBUFFER_INVALID_RESOURCE_FLAGS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_MISSING_ROOT_SIGNATURE_FLAGS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_HS_XOR_DS_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_VERTEX_SHADER_NOT_SET',
    'D3D12_MESSAGE_ID_META_COMMAND_UNSUPPORTED_PARAMS',
    'ID3D12Debug4',
    'D3D12_MESSAGE_ID_CREATE_DESCRIPTOR_HEAP_INVALID_DESC',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDRECORDER',
    'D3D12_MESSAGE_ID_DESTROY_ROOTSIGNATURE',
    'D3D12_MESSAGE_ID_SET_ROOT_UNORDERED_ACCESS_VIEW_INVALID',
    'D3D12_MESSAGE_ID_DESTROY_PIPELINESTATE',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDLAYOUT',
    'DXGI_FORMAT_R32G32B32_SINT',
    'D3D12_MESSAGE_ID_LOADPIPELINE_INVALIDDESC',
    'D3D12_MESSAGE_ID_CREATESHADERCACHESESSION_INVALIDARGS',
    'D3D12_HEAP_FLAG_CREATE_NOT_RESIDENT',
    'D3D12_MESSAGE_ID_CREATECOMMANDSIGNATURE_INVALID',
    '_RemotableHandle', 'DXGI_FORMAT_420_OPAQUE',
    'D3D12_MESSAGE_ID_FENCE_INVALIDOPERATION',
    'D3D12_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDRESOURCE',
    'D3D12_INFO_QUEUE_FILTER',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_UNSUPPORTED',
    'D3D12_MESSAGE_ID_DESTROY_COMMANDPOOL', 'DXGI_FORMAT_IA44',
    'D3D12_MESSAGE_ID_GETCOPYABLEFOOTPRINTS_UNSUPPORTED_BUFFER_WIDTH',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAM',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_TRANSCODE_ARRAY_SIZE_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSLOT0EXPECTED',
    'D3D12_MESSAGE_ID_CREATEBLENDSTATE_INVALIDLOGICOPS',
    'D3D12_MESSAGE_ID_RENDER_PASS_CANNOT_NEST_RENDER_PASSES',
    'D3D12_MESSAGE_ID_COPY_INVALIDLAYOUT',
    'D3D12_MESSAGE_ID_CREATEMESHSHADER_MISMATCHEDASMSPAYLOADSIZE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_VERTEX_BUFFER_TOO_SMALL',
    'D3D12_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDESC',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_PROCESSOR_CAPS_FAILURE',
    'DXGI_SAMPLE_DESC', 'D3D12_MESSAGE_ID_UNKNOWN',
    'D3D12_MESSAGE_ID_CREATERESOURCEANDHEAP_NULLRESOURCEPROPERTIES',
    'D3D12_HEAP_FLAG_DENY_RT_DS_TEXTURES',
    'D3D12_RESOURCE_DIMENSION_BUFFER',
    'D3D12_MESSAGE_ID_MAP_INVALIDRANGE',
    'D3D12_RESOURCE_FLAG_DENY_SHADER_RESOURCE',
    'D3D12_MESSAGE_ID_DESTROY_HEAP',
    'D3D12_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCLASSLINKAGE',
    'D3D12_MESSAGE_ID_CREATE_VIDEODECODECOMMANDQUEUE',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_LIST_VIDEO_NOT_SUPPORTED',
    'DXGI_FORMAT_R32G32_TYPELESS',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAMTORASTERIZER',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DRAW_INVALID_PRIMITIVETOPOLOGY',
    'D3D12_MESSAGE_ID_SET_PIPELINE_STACK_SIZE_ERROR',
    'D3D12_MESSAGE_ID_CREATE_COMMAND_RECORDER_VIDEO_NOT_SUPPORTED',
    'D3D12_MESSAGE_ID_SET_ROOT_CONSTANT_BUFFER_VIEW_INVALID',
    'D3D12_MESSAGE_ID_CREATE_LIBRARY',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_TABLE_REGISTER_INDEX_OUT_OF_BOUNDS',
    'D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSCOMMANDQUEUE',
    'DXGI_FORMAT_BC7_UNORM', 'DXGI_FORMAT_AI44',
    'D3D12_MESSAGE_ID_CREATEDEVICE_WARNING',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_SHADER_LINKAGE_REGISTERINDEX',
    'D3D12_MESSAGE_ID_OBJECT_EVICTED_WHILE_STILL_IN_USE',
    'D3D12_TEXTURE_LAYOUT',
    'D3D12_MESSAGE_ID_CREATERESOURCE_INVALIDARG_RETURN',
    'D3D12_MESSAGE_ID_DESTROY_PROTECTED_RESOURCE_SESSION',
    'D3D12_HEAP_TYPE_READBACK',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_NULLSRC',
    'DXGI_FORMAT_R8_TYPELESS',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_DUPLICATESEMANTIC',
    'D3D12_MESSAGE_ID_GETCOPYABLELAYOUT_INVALIDSUBRESOURCERANGE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_DSTREGIONOUTOFBOUNDS',
    'D3D12_MESSAGE_ID_SHADERCACHESESSION_STOREVALUE_ALREADYPRESENT',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_ROOT_ARGUMENT_UNINITIALIZED',
    'D3D12_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDPLANESLICE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDDSTOFFSET',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_INVALIDDSTRESOURCE',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_OFFSET_ALIGNMENT',
    'D3D12_MESSAGE_ID_CLOSE_COMMAND_LIST_OPEN_QUERY',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_DECODE_HEAP_CAPS_UNSUPPORTED',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSTEPRATECHANGE',
    'D3D12_HEAP_TYPE_CUSTOM',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOENCODECOMMANDQUEUE',
    'DXGI_FORMAT_AYUV',
    'D3D12_MESSAGE_ID_CREATEPIPELINELIBRARY_UNSUPPORTED',
    'D3D12_MESSAGE_ID_D3D12_MESSAGES_END',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_INVALID_STREAM',
    'D3D12_MESSAGE_ID_OBJECT_ACCESSED_WHILE_STILL_IN_USE',
    'DXGI_FORMAT_R8G8_SINT', 'ID3D12InfoQueue1',
    'D3D12_MESSAGE_ID_UNMAP_INVALIDRANGE',
    'D3D12_MESSAGE_ID_UNMAP_RANGE_NOT_EMPTY',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_PS_OUTPUT_RT_OUTPUT_MISMATCH',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERTYPE',
    'D3D12_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_MISMATCHINGCLEARVALUE',
    'D3D12_MESSAGE_ID_COMMAND_LIST_DISPATCH_ROOT_SIGNATURE_NOT_SET',
    'D3D12_MESSAGE_ID_RESOURCE_BARRIER_POSSIBLE_BEFORE_AFTER_MISMATCH',
    'D3D12_MESSAGE_ID_DESTROY_VIDEODECODERHEAP',
    'D3D12_MESSAGE_ID_LIVE_CRYPTO_SESSION',
    'D3D12_MESSAGE_ID_RSSETSHADINGRATEIMAGE_REQUIRES_TIER_2',
    'D3D12_MESSAGE_ID_CREATE_MONITOREDFENCE', 'DXGI_FORMAT_P010',
    'D3D12_GPU_BASED_VALIDATION_FLAGS_NONE',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_NULLSRC',
    'D3D12_MESSAGE_ID_DRAW_EMPTY_SCISSOR_RECTANGLE',
    'D3D12_MESSAGE_ID_CORRUPTED_MULTITHREADING',
    'D3D12_MESSAGE_ID_RESOLVESUBRESOURCE_SAMPLER_FEEDBACK_INVALID_MIP_LEVEL_COUNT',
    'D3D12_MESSAGE_ID_LIVE_VIDEOMOTIONVECTORHEAP',
    'D3D12_MESSAGE_ID_VARIABLE_SHADING_RATE_NOT_ALLOWED_WITH_TIR',
    'D3D12_MESSAGE_ID_LIVE_VIDEODECODERHEAP',
    'D3D12_MESSAGE_ID_CREATECOMPUTESHADER_OUTOFMEMORY',
    'D3D12_MESSAGE_ID_CREATEPIPELINESTATE_CACHEDBLOBADAPTERMISMATCH',
    'D3D12_MESSAGE_ID_SAMPLEPOSITIONS_MISMATCH_RECORDTIME_ASSUMEDFROMCLEAR',
    'D3D12_MESSAGE_ID_SETSAMPLEPOSITIONS_INVALIDARGS',
    'D3D12_MESSAGE_ID_CREATE_VIDEOPROCESSSTREAM',
    'D3D12_MESSAGE_ID_CREATEINPUTLAYOUT_TOOMANYELEMENTS',
    'D3D12_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEEXTENSIONSNOTSUPPORTED',
    'D3D12_HEAP_FLAGS',
    'D3D12_MESSAGE_ID_CREATEGRAPHICSPIPELINESTATE_INVALID_SAMPLE_DESC',
    'D3D12_MESSAGE_ID_OUT_OF_BOUNDS_BARRIER_SUBRESOURCE_RANGE',
    'ID3D12Resource',
    'D3D12_MESSAGE_ID_GEOMETRY_SHADER_OUTPUTTING_BOTH_VIEWPORT_ARRAY_INDEX_AND_SHADING_RATE_NOT_SUPPORTED_ON_DEVICE',
    'D3D12_MESSAGE_ID_GPU_BASED_VALIDATION_DESCRIPTOR_UNINITIALIZED',
    'D3D12_MESSAGE_ID_UNMAP_INVALIDSUBRESOURCE', 'D3D12_HEAP_TYPE',
    'D3D12_MESSAGE_ID_ATOMICCOPYBUFFER_INVALID_ARCHITECTURE',
    'D3D12_MESSAGE_ID_EXECUTE_INDIRECT_INVALID_PARAMETERS',
    'D3D12_GPU_BASED_VALIDATION_FLAGS',
    'D3D12_MESSAGE_ID_EVICT_UNDERFLOW',
    'D3D12_RESOURCE_DIMENSION_UNKNOWN',
    'D3D12_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MASKMISMATCH',
    'D3D12_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFLAGS',
    'D3D12_MESSAGE_ID_GETHEAPPROPERTIES_INVALIDRESOURCE',
    'D3D12_MESSAGE_ID_SHADING_RATE_IMAGE_INCORRECT_MIP_LEVEL',
    'D3D12_MESSAGE_ID_CREATE_VIDEO_DECODER_UNSUPPORTED',
    'D3D12_MESSAGE_ID_DESTROY_VIDEOPROCESSCOMMANDLIST',
    'D3D12_MESSAGE_ID_CORRUPTED_THIS',
    'DXGI_FORMAT_R10G10B10A2_TYPELESS', 'DXGI_FORMAT_R16_SINT',
    'D3D12_MESSAGE_ID_COPYTEXTUREREGION_INVALIDSRCDIMENSIONS',
    'D3D12_MESSAGE_ID_EXECUTECOMMANDLISTS_WRONGSWAPCHAINBUFFERREFERENCE',
    'DXGI_FORMAT_NV12'
]


